"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileParser = void 0;
var FileParser = (function () {
    function FileParser(dataView) {
        this.data = dataView;
        this.pointer = 0;
    }
    FileParser.prototype.movePointer = function (bytes) {
        this.pointer += bytes;
        return this.pointer;
    };
    FileParser.prototype.readInt = function (bytes) {
        var clamp_bytes = Math.min(bytes, this.data.byteLength - this.pointer);
        if (clamp_bytes < 1) {
            return -1;
        }
        var value = 0;
        if (clamp_bytes > 1) {
            for (var i = 1; i <= clamp_bytes - 1; i += 1) {
                value += this.data.getUint8(this.pointer) * Math.pow(256, (clamp_bytes - i));
                this.pointer += 1;
            }
        }
        value += this.data.getUint8(this.pointer);
        this.pointer += 1;
        return value;
    };
    FileParser.prototype.readStr = function (bytes) {
        var text = "";
        for (var char = 1; char <= bytes; char += 1)
            text += String.fromCharCode(this.readInt(1));
        return text;
    };
    FileParser.prototype.readIntVLV = function () {
        var value = 0;
        if (this.pointer >= this.data.byteLength) {
            return -1;
        }
        else if (this.data.getUint8(this.pointer) < 128) {
            value = this.readInt(1);
        }
        else {
            var FirstBytes = [];
            while (this.data.getUint8(this.pointer) >= 128) {
                FirstBytes.push(this.readInt(1) - 128);
            }
            var lastByte = this.readInt(1);
            for (var dt = 1; dt <= FirstBytes.length; dt += 1) {
                var num = FirstBytes[FirstBytes.length - dt];
                if (typeof num === "number") {
                    value += num * Math.pow(128, dt);
                }
            }
            value += lastByte;
        }
        return value;
    };
    return FileParser;
}());
exports.FileParser = FileParser;
//# sourceMappingURL=FileParser.js.map