import { FileParser } from "./FileParser";
interface PcxHeader {
    identifier: number;
    version: number;
    encoding: number;
    bitsPerPixel: number;
    xStart: number;
    yStart: number;
    xEnd: number;
    yEnd: number;
    hRes: number;
    vRes: number;
    palette16: Uint8Array;
    reserved1: number;
    numBitPlanes: number;
    bytesPerLine: number;
    paletteType: number;
    hSize: number;
    vSize: number;
    reserved2: number;
}
export declare class PcxParser extends FileParser {
    readonly header: PcxHeader;
    readonly width: number;
    readonly height: number;
    readonly palette: Uint8Array;
    readonly pixels: Uint8Array;
    constructor(buffer: ArrayBuffer);
    getPixels(): Uint8Array;
    private readHeader;
    private validateHeader;
    private readPalette;
    private readData;
    private getPalValues;
}
export {};
