import { BITMAP, CLIPPING_RECTANGLE, PACKFILE, RGB } from "./types";
export declare const screen: BITMAP;
export declare function create_bitmap(width: number, height: number): BITMAP;
export declare function create_bitmap_ex(color_depth: number, width: number, height: number): BITMAP;
export declare function create_sub_bitmap(parent: BITMAP | undefined, x: number, y: number, width: number, height: number): BITMAP | null;
export declare function create_video_bitmap(width: number, height: number): BITMAP;
export declare function create_system_bitmap(width: number, height: number): BITMAP;
export declare function destroy_bitmap(bitmap: BITMAP | undefined): void;
export declare function lock_bitmap(bitmap: BITMAP | undefined): void;
export declare function bitmap_color_depth(bmp: BITMAP | undefined): number;
export declare function bitmap_mask_color(bmp: BITMAP | undefined): number;
export declare function is_same_bitmap(bmp1: BITMAP | undefined, bmp2: BITMAP | undefined): boolean;
export declare function is_planar_bitmap(bmp: BITMAP | undefined): boolean;
export declare function is_linear_bitmap(bmp: BITMAP | undefined): boolean;
export declare function is_memory_bitmap(bmp: BITMAP | undefined): boolean;
export declare function is_screen_bitmap(bmp: BITMAP | undefined): boolean;
export declare function is_video_bitmap(bmp: BITMAP | undefined): boolean;
export declare function is_system_bitmap(bmp: BITMAP | undefined): boolean;
export declare function is_sub_bitmap(bmp: BITMAP | undefined): boolean;
export declare function acquire_bitmap(bmp: BITMAP | undefined): void;
export declare function release_bitmap(bmp: BITMAP | undefined): void;
export declare function acquire_screen(): void;
export declare function release_screen(): void;
export declare function set_clip_rect(bitmap: BITMAP | undefined, x1: number, y1: number, x2: number, y2: number): void;
export declare function get_clip_rect(bitmap: BITMAP | undefined): CLIPPING_RECTANGLE | null;
export declare function add_clip_rect(bitmap: BITMAP | undefined, x1: number, y1: number, x2: number, y2: number): void;
export declare function set_clip_state(bitmap: BITMAP | undefined, state: boolean): void;
export declare function get_clip_state(bitmap: BITMAP | undefined): number;
export declare function is_inside_bitmap(bmp: BITMAP | undefined, x: number, y: number, clip: number): boolean;
export declare function load_bitmap(filename: string, pal?: RGB): BITMAP;
export declare function load_bmp(filename: string): BITMAP;
export declare function load_bmp_pf(f: PACKFILE, pal?: RGB): void;
export declare function load_lbm(filename: string, pal?: RGB): BITMAP;
export declare function load_pcx(filename: string, pal?: RGB): BITMAP;
export declare function load_pcx_pf(f: PACKFILE, pal?: RGB): void;
export declare function load_tga(filename: string, pal?: RGB): BITMAP;
export declare function load_tga_pf(f: PACKFILE, pal?: RGB): void;
export declare function save_bitmap(filename: string, bmp: BITMAP | undefined, pal?: RGB): void;
export declare function save_bmp(filename: string, bmp: BITMAP | undefined, pal?: RGB): void;
export declare function save_bmp_pf(f: PACKFILE, bmp: BITMAP | undefined, pal?: RGB): void;
export declare function save_pcx(filename: string, bmp: BITMAP | undefined, pal?: RGB): void;
export declare function save_pcx_pf(f: PACKFILE, bmp: BITMAP | undefined, pal?: RGB): void;
export declare function save_tga(filename: string, bmp: BITMAP | undefined, pal?: RGB): void;
export declare function save_tga_pf(f: PACKFILE, bmp: BITMAP | undefined, pal?: RGB): void;
export declare function register_bitmap_file_type(ext: string, load: (filename: string, pal?: RGB) => BITMAP | undefined, save: (filename: string, pal?: RGB) => number): void;
export declare function set_color_conversion(mode: number): void;
export declare function loadpng_init(): number;
