"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.palette_color = exports.geta_depth = exports.getb_depth = exports.getg_depth = exports.getr_depth = exports.geta = exports.getb = exports.getg = exports.getr = exports.geta32 = exports.getb32 = exports.getb24 = exports.getb16 = exports.getb15 = exports.getb8 = exports.getg32 = exports.getg24 = exports.getg16 = exports.getg15 = exports.getg8 = exports.getr32 = exports.getr24 = exports.getr16 = exports.getr15 = exports.getr8 = exports.makecol15_dither = exports.makeacol = exports.makeacol_depth = exports.makecol_depth = exports.makecol = exports.makeacol32 = exports.makecol32 = exports.makecol24 = exports.makecol16 = exports.makecol15 = exports.makecol8 = void 0;
var _color_depth = 32;
function makecol8(r, g, b) {
    return makecol32(r, g, b);
}
exports.makecol8 = makecol8;
function makecol15(r, g, b) {
    return makecol32(r, g, b);
}
exports.makecol15 = makecol15;
function makecol16(r, g, b) {
    return makecol32(r, g, b);
}
exports.makecol16 = makecol16;
function makecol24(r, g, b) {
    return makecol32(r, g, b);
}
exports.makecol24 = makecol24;
function makecol32(r, g, b) {
    return (r << 0) | (g << 8) | (b << 16);
}
exports.makecol32 = makecol32;
function makeacol32(r, g, b, a) {
    return (r << 0) | (g << 8) | (b << 16) | (a << 24);
}
exports.makeacol32 = makeacol32;
function makecol(r, g, b) {
    return makecol_depth(_color_depth, r, g, b);
}
exports.makecol = makecol;
function makecol_depth(color_depth, r, g, b) {
    switch (color_depth) {
        case 8:
            return makecol8(r, g, b);
        case 15:
            return makecol15(r, g, b);
        case 16:
            return makecol16(r, g, b);
        case 24:
            return makecol24(r, g, b);
        case 32:
            return makecol32(r, g, b);
        default:
            return 0;
    }
}
exports.makecol_depth = makecol_depth;
function makeacol_depth(color_depth, r, g, b, a) {
    switch (color_depth) {
        case 8:
            return makecol8(r, g, b);
        case 15:
            return makecol15(r, g, b);
        case 16:
            return makecol16(r, g, b);
        case 24:
            return makecol24(r, g, b);
        case 32:
            return makeacol32(r, g, b, a);
        default:
            return 0;
    }
}
exports.makeacol_depth = makeacol_depth;
function makeacol(r, g, b, a) {
    return makeacol_depth(_color_depth, r, g, b, a);
}
exports.makeacol = makeacol;
function makecol15_dither(r, g, b, x, y) {
    void x;
    void y;
    return makecol32(r, g, b);
}
exports.makecol15_dither = makecol15_dither;
function getr8(c) {
    return getr32(c);
}
exports.getr8 = getr8;
function getr15(c) {
    return getr32(c);
}
exports.getr15 = getr15;
function getr16(c) {
    return getr32(c);
}
exports.getr16 = getr16;
function getr24(c) {
    return getr32(c);
}
exports.getr24 = getr24;
function getr32(c) {
    return (c >> 0) & 0xff;
}
exports.getr32 = getr32;
function getg8(c) {
    return getg32(c);
}
exports.getg8 = getg8;
function getg15(c) {
    return getg32(c);
}
exports.getg15 = getg15;
function getg16(c) {
    return getg32(c);
}
exports.getg16 = getg16;
function getg24(c) {
    return getg32(c);
}
exports.getg24 = getg24;
function getg32(c) {
    return (c >> 8) & 0xff;
}
exports.getg32 = getg32;
function getb8(c) {
    return getb32(c);
}
exports.getb8 = getb8;
function getb15(c) {
    return getb32(c);
}
exports.getb15 = getb15;
function getb16(c) {
    return getb32(c);
}
exports.getb16 = getb16;
function getb24(c) {
    return getb32(c);
}
exports.getb24 = getb24;
function getb32(c) {
    return (c >> 16) & 0xff;
}
exports.getb32 = getb32;
function geta32(c) {
    return (c >> 24) & 0xff;
}
exports.geta32 = geta32;
function getr(c) {
    return getr_depth(_color_depth, c);
}
exports.getr = getr;
function getg(c) {
    return getg_depth(_color_depth, c);
}
exports.getg = getg;
function getb(c) {
    return getb_depth(_color_depth, c);
}
exports.getb = getb;
function geta(c) {
    return geta_depth(_color_depth, c);
}
exports.geta = geta;
function getr_depth(color_depth, c) {
    switch (color_depth) {
        case 8:
            return getr8(c);
        case 15:
            return getr15(c);
        case 16:
            return getr16(c);
        case 24:
            return getr24(c);
        case 32:
            return getr32(c);
        default:
            return 0;
    }
}
exports.getr_depth = getr_depth;
function getg_depth(color_depth, c) {
    switch (color_depth) {
        case 8:
            return getg8(c);
        case 15:
            return getg15(c);
        case 16:
            return getg16(c);
        case 24:
            return getg24(c);
        case 32:
            return getg32(c);
        default:
            return 0;
    }
}
exports.getg_depth = getg_depth;
function getb_depth(color_depth, c) {
    switch (color_depth) {
        case 8:
            return getb8(c);
        case 15:
            return getb15(c);
        case 16:
            return getb16(c);
        case 24:
            return getb24(c);
        case 32:
            return getb32(c);
        default:
            return 0;
    }
}
exports.getb_depth = getb_depth;
function geta_depth(color_depth, c) {
    if (color_depth === 32)
        return geta32(c);
    return 0;
}
exports.geta_depth = geta_depth;
exports.palette_color = [0, 1, 2, 3, 4, 5, 6, 7];
//# sourceMappingURL=color.js.map