"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cpu_capabilities = exports.cpu_model = exports.cpu_family = exports.cpu_vendor = exports.check_cpu = exports.get_desktop_resolution = exports.desktop_color_depth = exports.set_close_button_callback = exports.set_window_title = exports.allegro_message = exports.os_multitasking = exports.os_version = exports.os_type = exports.MAKE_VERSION = exports.AL_ID = exports.ALLEGRO_DATE = exports.ALLEGRO_DATE_STR = exports.ALLEGRO_VERSION_STR = exports.ALLEGRO_WIP_VERSION = exports.ALLEGRO_SUB_VERSION = exports.ALLEGRO_VERSION = exports.allegro_error = exports.allegro_id = exports.END_OF_MAIN = exports.allegro_exit = exports.atexit = exports.allegro_init = exports.SYSTEM_NONE = exports.SYSTEM_AUTODETECT = exports.install_allegro = exports._set_loop_interval = void 0;
var graphics_1 = require("./graphics");
var core_1 = require("./core");
var debug_1 = require("./debug");
var sprintf_1 = require("./sprintf");
var _loop_interval = -1;
function _set_loop_interval(interval) {
    if (_loop_interval !== -1) {
        window.clearInterval(_loop_interval);
    }
    if (interval !== -1) {
        _loop_interval = interval;
    }
}
exports._set_loop_interval = _set_loop_interval;
function install_allegro(system_id, errno_ptr, atexit_ptr) {
    void system_id;
    void errno_ptr;
    void atexit_ptr;
    check_cpu();
    debug_1.log("Allegro installed!");
    _set_loop_interval(window.setInterval(core_1._uberloop, 16.6));
    debug_1.log("Game loop initialised!");
    return 0;
}
exports.install_allegro = install_allegro;
exports.SYSTEM_AUTODETECT = 0;
exports.SYSTEM_NONE = AL_ID("N", "O", "N", "E");
function allegro_init() {
    return install_allegro(exports.SYSTEM_AUTODETECT, 0, atexit);
}
exports.allegro_init = allegro_init;
function atexit() {
    debug_1.log("Allegro destroyed");
}
exports.atexit = atexit;
function allegro_exit() {
    debug_1.log("Allegro exited.");
}
exports.allegro_exit = allegro_exit;
function END_OF_MAIN() {
}
exports.END_OF_MAIN = END_OF_MAIN;
exports.allegro_id = "Allegro TS";
exports.allegro_error = "";
exports.ALLEGRO_VERSION = 4;
exports.ALLEGRO_SUB_VERSION = 1;
exports.ALLEGRO_WIP_VERSION = 16;
exports.ALLEGRO_VERSION_STR = "4.1.16";
exports.ALLEGRO_DATE_STR = "2021";
exports.ALLEGRO_DATE = 0;
function AL_ID(a, b, c, d) {
    return ((a.charCodeAt(0) << 24) +
        (b.charCodeAt(0) << 16) +
        (c.charCodeAt(0) << 8) +
        d.charCodeAt(0));
}
exports.AL_ID = AL_ID;
function MAKE_VERSION(a, b, c) {
    return (a.charCodeAt(0) << 16) + (b.charCodeAt(0) << 8) + c.charCodeAt(0);
}
exports.MAKE_VERSION = MAKE_VERSION;
exports.os_type = "OSTYPE_BROWSER";
exports.os_version = 0;
exports.os_multitasking = true;
function allegro_message(text_format) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    alert(sprintf_1.vsprintf(text_format, args));
}
exports.allegro_message = allegro_message;
function set_window_title(name) {
    document.title = name;
}
exports.set_window_title = set_window_title;
function set_close_button_callback(proc) {
    window.onbeforeunload = proc;
}
exports.set_close_button_callback = set_close_button_callback;
function desktop_color_depth() {
    return 32;
}
exports.desktop_color_depth = desktop_color_depth;
function get_desktop_resolution() {
    return { width: graphics_1.gfx_driver.w, height: graphics_1.gfx_driver.h };
}
exports.get_desktop_resolution = get_desktop_resolution;
function check_cpu() {
    exports.cpu_vendor = "Browser CPU";
    exports.cpu_family = "Browser CPU Family";
    exports.cpu_model = "Browser CPU Model";
    exports.cpu_capabilities = 0;
}
exports.check_cpu = check_cpu;
exports.cpu_vendor = "";
exports.cpu_family = "";
exports.cpu_model = "";
exports.cpu_capabilities = 0;
//# sourceMappingURL=config.js.map