"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.free_config_entries = exports.list_config_sections = exports.list_config_entries = exports.set_config_id = exports.set_config_float = exports.set_config_hex = exports.set_config_int = exports.set_config_string = exports.get_config_text = exports.get_config_argv = exports.get_config_id = exports.get_config_float = exports.get_config_hex = exports.get_config_int = exports.get_config_string = exports.config_is_hooked = exports.hook_config_section = exports.reload_config_texts = exports.flush_config_state = exports.pop_config_state = exports.push_config_state = exports.override_config_data = exports.set_config_data = exports.set_config_file = void 0;
var core_1 = require("./core");
var debug_1 = require("./debug");
var configs = [];
var config = {
    file: "",
    data: {},
    ready: false,
    type: "config",
};
function _parse_config_file(data) {
    var conf = {};
    var lines = data
        .split("\n")
        .filter(function (line) { return !/^#/u.exec(line) && line.length > 0; });
    var section = "";
    lines.forEach(function (line) {
        var _a;
        if (/\[[a-zA-Z]*\]/u.exec(line)) {
            section = line.replace("[", "").replace("]", "");
        }
        else if (line.includes("=")) {
            var _b = __read(line.split("="), 2), key = _b[0], val = _b[1];
            var k = key === null || key === void 0 ? void 0 : key.trim();
            var v = val === null || val === void 0 ? void 0 : val.trim();
            if (typeof k === "string" && typeof v === "string") {
                conf[section] = __assign(__assign({}, conf[section]), (_a = {}, _a[k] = v, _a));
            }
        }
    });
    return conf;
}
function set_config_file(filename) {
    debug_1.log("Loading config " + filename + "...");
    config.file = filename;
    core_1._downloadables.push(config);
    var request = new XMLHttpRequest();
    request.open("GET", filename, true);
    request.send(null);
    request.onreadystatechange = function () {
        if (request.readyState === 4 && request.status === 200) {
            var type = request.getResponseHeader("Content-Type");
            if ((type === null || type === void 0 ? void 0 : type.indexOf("text")) !== 1) {
                config.data = _parse_config_file(request.responseText);
                config.ready = true;
            }
        }
    };
}
exports.set_config_file = set_config_file;
function set_config_data(data, length) {
    config.data = data;
    void length;
}
exports.set_config_data = set_config_data;
function override_config_data(data, length) {
    config.data = data;
    void length;
}
exports.override_config_data = override_config_data;
function push_config_state() {
    configs.push(config);
    config = {
        file: "",
        data: {},
        ready: false,
        type: "config",
    };
}
exports.push_config_state = push_config_state;
function pop_config_state() {
    var top = configs.pop();
    if (top) {
        config = top;
    }
}
exports.pop_config_state = pop_config_state;
function flush_config_state() {
}
exports.flush_config_state = flush_config_state;
function reload_config_texts(new_language) {
    void new_language;
}
exports.reload_config_texts = reload_config_texts;
function hook_config_section(section, intgetter, stringgetter, stringsetter) {
    void section;
    void intgetter;
    void stringgetter;
    void stringsetter;
}
exports.hook_config_section = hook_config_section;
function config_is_hooked(section) {
    void section;
    return false;
}
exports.config_is_hooked = config_is_hooked;
function get_config_string(section, name, def) {
    var _a, _b;
    return (_b = (_a = config.data[section]) === null || _a === void 0 ? void 0 : _a[name]) !== null && _b !== void 0 ? _b : def;
}
exports.get_config_string = get_config_string;
function get_config_int(section, name, def) {
    var _a;
    var data = (_a = config.data[section]) === null || _a === void 0 ? void 0 : _a[name];
    return typeof data === "string" ? parseInt(data, 10) : def;
}
exports.get_config_int = get_config_int;
function get_config_hex(section, name, def) {
    var _a;
    var data = (_a = config.data[section]) === null || _a === void 0 ? void 0 : _a[name];
    return typeof data === "string" ? parseInt(data, 10) : def;
}
exports.get_config_hex = get_config_hex;
function get_config_float(section, name, def) {
    var _a;
    var data = (_a = config.data[section]) === null || _a === void 0 ? void 0 : _a[name];
    return typeof data === "string" ? parseFloat(data) : def;
}
exports.get_config_float = get_config_float;
function get_config_id(section, name, def) {
    var _a, _b;
    return (_b = (_a = config.data[section]) === null || _a === void 0 ? void 0 : _a[name]) !== null && _b !== void 0 ? _b : def;
}
exports.get_config_id = get_config_id;
function get_config_argv(section, name) {
    var _a, _b;
    return ((_b = (_a = config.data[section]) === null || _a === void 0 ? void 0 : _a[name]) !== null && _b !== void 0 ? _b : "").split(" ");
}
exports.get_config_argv = get_config_argv;
function get_config_text(msg) {
    return msg;
}
exports.get_config_text = get_config_text;
function set_config_string(section, name, val) {
    var _a;
    if (!section) {
        config.data[section] = {};
    }
    config.data[section] = __assign(__assign({}, config.data[section]), (_a = {}, _a[name] = val, _a));
}
exports.set_config_string = set_config_string;
function set_config_int(section, name, val) {
    var _a;
    if (!section) {
        config.data[section] = {};
    }
    config.data[section] = __assign(__assign({}, config.data[section]), (_a = {}, _a[name] = val.toString(), _a));
}
exports.set_config_int = set_config_int;
function set_config_hex(section, name, val) {
    var _a;
    if (!section) {
        config.data[section] = {};
    }
    config.data[section] = __assign(__assign({}, config.data[section]), (_a = {}, _a[name] = val.toString(), _a));
}
exports.set_config_hex = set_config_hex;
function set_config_float(section, name, val) {
    var _a;
    if (!section) {
        config.data[section] = {};
    }
    config.data[section] = __assign(__assign({}, config.data[section]), (_a = {}, _a[name] = val.toString(), _a));
}
exports.set_config_float = set_config_float;
function set_config_id(section, name, val) {
    var _a;
    if (!section) {
        config.data[section] = {};
    }
    config.data[section] = __assign(__assign({}, config.data[section]), (_a = {}, _a[name] = val.toString(), _a));
}
exports.set_config_id = set_config_id;
function list_config_entries(section) {
    var _a;
    return Object.keys((_a = config.data[section]) !== null && _a !== void 0 ? _a : {});
}
exports.list_config_entries = list_config_entries;
function list_config_sections(names) {
    void names;
    return Object.keys(config.data);
}
exports.list_config_sections = list_config_sections;
function free_config_entries(names) {
    names.forEach(function (name) { return delete config.data[name]; });
}
exports.free_config_entries = free_config_entries;
//# sourceMappingURL=configuration.js.map