"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.allegro_ready = exports.init_allegro_ts = exports.loading_bar = exports._progress_check = exports._uberloop = exports._downloadables = void 0;
var bitmap_1 = require("./bitmap");
var color_1 = require("./color");
var debug_1 = require("./debug");
var font_1 = require("./font");
var graphics_1 = require("./graphics");
var keyboard_1 = require("./keyboard");
var math_1 = require("./math");
var mouse_1 = require("./mouse");
var primitives_1 = require("./primitives");
var touch_1 = require("./touch");
var timer_1 = require("./timer");
exports._downloadables = [];
function _uberloop() {
    mouse_1._mouse_loop();
    keyboard_1._keyboard_loop();
    mouse_1._mouse_loop_reset();
    touch_1._touch_loop();
}
exports._uberloop = _uberloop;
var _loader_init_time = 0;
var _bar_proc = loading_bar;
function _progress_check() {
    return __awaiter(this, void 0, void 0, function () {
        var loaded, num_assets, num_loaded;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    loaded = false;
                    _a.label = 1;
                case 1:
                    if (!!loaded) return [3, 3];
                    num_assets = exports._downloadables.length;
                    num_loaded = exports._downloadables.filter(function (down) { return down.ready; }).length;
                    _bar_proc(num_assets / num_loaded);
                    if (num_loaded >= num_assets) {
                        debug_1.log("Loading complete! Took " + ((Date.now() - _loader_init_time) /
                            1000).toFixed(1) + " seconds!");
                        primitives_1.clear_bitmap(bitmap_1.screen);
                        loaded = true;
                    }
                    return [4, timer_1.rest(100)];
                case 2:
                    _a.sent();
                    return [3, 1];
                case 3: return [2];
            }
        });
    });
}
exports._progress_check = _progress_check;
function loading_bar(progress) {
    primitives_1.rectfill(bitmap_1.screen, 5, graphics_1.SCREEN_H - 55, graphics_1.SCREEN_W - 10, 50, color_1.makecol(0, 0, 0));
    primitives_1.rectfill(bitmap_1.screen, 10, graphics_1.SCREEN_H - 50, graphics_1.SCREEN_W - 10, graphics_1.SCREEN_H - 10, color_1.makecol(255, 255, 255));
    primitives_1.rectfill(bitmap_1.screen, 15, graphics_1.SCREEN_H - 45, graphics_1.SCREEN_W - 15, graphics_1.SCREEN_H - 15, color_1.makecol(0, 0, 0));
    primitives_1.rectfill(bitmap_1.screen, 20, graphics_1.SCREEN_H - 40, math_1.scaleclamp(progress, 0, 1, 20, graphics_1.SCREEN_W - 20), graphics_1.SCREEN_H - 20, color_1.makecol(255, 255, 255));
}
exports.loading_bar = loading_bar;
function init_allegro_ts(canvas_id, main) {
    var cv = document.getElementById(canvas_id);
    if (!cv) {
        debug_1._error("Can't find canvas with id " + canvas_id);
        return;
    }
    var ctx = cv.getContext("2d");
    if (!ctx) {
        throw new Error("Context not defined");
    }
    bitmap_1.screen.canvas = cv;
    bitmap_1.screen.context = ctx;
    if (main) {
        window.addEventListener("load", function () {
            void boot(main);
        });
    }
}
exports.init_allegro_ts = init_allegro_ts;
function boot(main) {
    return __awaiter(this, void 0, void 0, function () {
        var code;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, main()];
                case 1:
                    code = _a.sent();
                    graphics_1.set_gfx_mode(graphics_1.GFX_AUTODETECT_WINDOWED, 320, 200, 0, 0);
                    primitives_1.clear_to_color(bitmap_1.screen, color_1.makecol(100, 100, 100));
                    font_1.textprintf_centre_ex(bitmap_1.screen, graphics_1.font, graphics_1.SCREEN_W / 2, graphics_1.SCREEN_H / 2, color_1.makecol(255, 255, 255), -1, "Program ended with code %i", code);
                    return [2];
            }
        });
    });
}
function allegro_ready() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            _loader_init_time = Date.now();
            debug_1.log("Loader initialised!");
            return [2, _progress_check()];
        });
    });
}
exports.allegro_ready = allegro_ready;
//# sourceMappingURL=core.js.map