"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.wipe_log = exports._allog = exports.log = exports.enable_debug = exports._onerror = exports._error = void 0;
var _debug_enabled = false;
var _debug_element = null;
var ALLEGRO_CONSOLE = true;
function _error(string) {
    log("[ERROR] " + string);
    alert(string);
}
exports._error = _error;
function _onerror(e) {
    var _a;
    var fa = e.filename.split("/");
    fa.reverse();
    log("[" + ((_a = fa[0]) !== null && _a !== void 0 ? _a : "") + ":" + e.lineno + ":" + e.colno + "] " + e.message);
}
exports._onerror = _onerror;
function enable_debug(id) {
    _debug_element = document.getElementById(id);
    window.addEventListener("error", _onerror);
    if (_debug_element)
        _debug_enabled = true;
}
exports.enable_debug = enable_debug;
function log(string) {
    if (ALLEGRO_CONSOLE)
        console.log(string);
    if (!_debug_enabled || !_debug_element)
        return;
    _debug_element.innerHTML = _debug_element.innerHTML + string + "<br/>";
}
exports.log = log;
function _allog(string) {
    if (ALLEGRO_CONSOLE)
        console.log(string);
    if (!_debug_enabled || !_debug_element)
        return;
    _debug_element.innerHTML = _debug_element.innerHTML + string + "<br/>";
}
exports._allog = _allog;
function wipe_log() {
    if (!_debug_enabled || !_debug_element)
        return;
    _debug_element.innerHTML = "";
}
exports.wipe_log = wipe_log;
//# sourceMappingURL=debug.js.map