import { BITMAP, FONT, RGB } from "./types";
export declare function register_font_file_type(ext: string, load: (filename: string, pal: RGB, param: string) => void): void;
export declare function load_font(filename: string, size?: number): FONT;
export declare function destroy_font(f: FONT): void;
export declare function make_trans_font(f: FONT): void;
export declare function is_color_font(f: FONT): boolean;
export declare function is_mono_font(f: FONT): boolean;
export declare function is_compatible_font(f: FONT): boolean;
export declare function get_font_ranges(f: FONT): number;
export declare function get_font_range_begin(f: FONT, range: number): number;
export declare function get_font_range_end(f: FONT, range: number): number;
export declare function extract_font_range(f: FONT, begin: number, end: number): FONT;
export declare function transpose_font(f: FONT, drange: number): FONT;
export declare function merge_fonts(f1: FONT, f2: FONT): FONT;
export declare const allegro_404_char = "^";
export declare function text_length(f: FONT, str: string): number;
export declare function text_height(f: FONT): number;
export declare function textout_ex(bitmap: BITMAP | undefined, f: FONT, s: string, x: number, y: number, colour: number, bg: number): void;
export declare function textout_centre_ex(bitmap: BITMAP | undefined, f: FONT, s: string, x: number, y: number, colour: number, bg: number): void;
export declare function textout_right_ex(bitmap: BITMAP | undefined, f: FONT, s: string, x: number, y: number, colour: number, bg: number): void;
export declare function textout_justify_ex(bitmap: BITMAP | undefined, f: FONT, s: string, x: number, y: number, colour: number, bg: number): void;
export declare function textprintf_ex(bitmap: BITMAP | undefined, f: FONT, x: number, y: number, colour: number, bg: number, s: string, ...args: (number | string)[]): void;
export declare function textprintf_centre_ex(bitmap: BITMAP | undefined, f: FONT, x: number, y: number, colour: number, bg: number, s: string, ...args: (number | string)[]): void;
export declare function textprintf_right_ex(bitmap: BITMAP | undefined, f: FONT, x: number, y: number, colour: number, bg: number, s: string, ...args: (number | string)[]): void;
export declare function textprintf_justify_ex(bitmap: BITMAP | undefined, f: FONT, x: number, y: number, colour: number, bg: number, s: string, ...args: (number | string)[]): void;
