"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.textprintf_justify_ex = exports.textprintf_right_ex = exports.textprintf_centre_ex = exports.textprintf_ex = exports.textout_justify_ex = exports.textout_right_ex = exports.textout_centre_ex = exports.textout_ex = exports.text_height = exports.text_length = exports.allegro_404_char = exports.merge_fonts = exports.transpose_font = exports.extract_font_range = exports.get_font_range_end = exports.get_font_range_begin = exports.get_font_ranges = exports.is_compatible_font = exports.is_mono_font = exports.is_color_font = exports.make_trans_font = exports.destroy_font = exports.load_font = exports.register_font_file_type = void 0;
var primitives_1 = require("./primitives");
var sprintf_1 = require("./sprintf");
var bitmap_1 = require("./bitmap");
var _text_len_canvas = null;
var _num_fonts = 0;
function register_font_file_type(ext, load) {
    void ext;
    void load;
}
exports.register_font_file_type = register_font_file_type;
function load_font(filename, size) {
    if (size === void 0) { size = 12; }
    var s = document.createElement("style");
    _num_fonts += 1;
    var fontname = "font" + _num_fonts;
    s.id = fontname;
    s.type = "text/css";
    document.head.appendChild(s);
    s.textContent = "@font-face { font-family: " + fontname + "; src:url('" + filename + "');}";
    return { element: s, file: filename, name: fontname, size: size, type: "fnt" };
}
exports.load_font = load_font;
function destroy_font(f) {
    void f;
}
exports.destroy_font = destroy_font;
function make_trans_font(f) {
    void f;
}
exports.make_trans_font = make_trans_font;
function is_color_font(f) {
    void f;
    return true;
}
exports.is_color_font = is_color_font;
function is_mono_font(f) {
    void f;
    return false;
}
exports.is_mono_font = is_mono_font;
function is_compatible_font(f) {
    void f;
    return true;
}
exports.is_compatible_font = is_compatible_font;
function get_font_ranges(f) {
    void f;
    return 1;
}
exports.get_font_ranges = get_font_ranges;
function get_font_range_begin(f, range) {
    void f;
    void range;
    return 1;
}
exports.get_font_range_begin = get_font_range_begin;
function get_font_range_end(f, range) {
    void f;
    void range;
    return 1;
}
exports.get_font_range_end = get_font_range_end;
function extract_font_range(f, begin, end) {
    void begin;
    void end;
    return f;
}
exports.extract_font_range = extract_font_range;
function transpose_font(f, drange) {
    void drange;
    return f;
}
exports.transpose_font = transpose_font;
function merge_fonts(f1, f2) {
    void f2;
    return f1;
}
exports.merge_fonts = merge_fonts;
exports.allegro_404_char = "^";
function text_length(f, str) {
    if (!_text_len_canvas) {
        _text_len_canvas = bitmap_1.create_bitmap(0, 0);
    }
    _text_len_canvas.context.font = f.size + "px " + f.name;
    var metrics = _text_len_canvas.context.measureText(str);
    return metrics.width;
}
exports.text_length = text_length;
function text_height(f) {
    return f.size;
}
exports.text_height = text_height;
function textout_ex(bitmap, f, s, x, y, colour, bg) {
    _textout(bitmap, f, s, x, y, colour, bg, "left");
}
exports.textout_ex = textout_ex;
function textout_centre_ex(bitmap, f, s, x, y, colour, bg) {
    _textout(bitmap, f, s, x, y, colour, bg, "center");
}
exports.textout_centre_ex = textout_centre_ex;
function textout_right_ex(bitmap, f, s, x, y, colour, bg) {
    _textout(bitmap, f, s, x, y, colour, bg, "right");
}
exports.textout_right_ex = textout_right_ex;
function textout_justify_ex(bitmap, f, s, x, y, colour, bg) {
    _textout(bitmap, f, s, x, y, colour, bg, "center");
}
exports.textout_justify_ex = textout_justify_ex;
function textprintf_ex(bitmap, f, x, y, colour, bg, s) {
    var args = [];
    for (var _i = 7; _i < arguments.length; _i++) {
        args[_i - 7] = arguments[_i];
    }
    _textout(bitmap, f, sprintf_1.vsprintf(s, args), x, y, colour, bg, "left");
}
exports.textprintf_ex = textprintf_ex;
function textprintf_centre_ex(bitmap, f, x, y, colour, bg, s) {
    var args = [];
    for (var _i = 7; _i < arguments.length; _i++) {
        args[_i - 7] = arguments[_i];
    }
    _textout(bitmap, f, sprintf_1.vsprintf(s, args), x, y, colour, bg, "center");
}
exports.textprintf_centre_ex = textprintf_centre_ex;
function textprintf_right_ex(bitmap, f, x, y, colour, bg, s) {
    var args = [];
    for (var _i = 7; _i < arguments.length; _i++) {
        args[_i - 7] = arguments[_i];
    }
    _textout(bitmap, f, sprintf_1.vsprintf(s, args), x, y, colour, bg, "right");
}
exports.textprintf_right_ex = textprintf_right_ex;
function textprintf_justify_ex(bitmap, f, x, y, colour, bg, s) {
    var args = [];
    for (var _i = 7; _i < arguments.length; _i++) {
        args[_i - 7] = arguments[_i];
    }
    _textout(bitmap, f, sprintf_1.vsprintf(s, args), x, y, colour, bg, "center");
}
exports.textprintf_justify_ex = textprintf_justify_ex;
function _textout(bitmap, f, s, x, y, colour, bg, text_align) {
    if (!bitmap) {
        return;
    }
    bitmap.context.font = f.size + "px " + f.name;
    bitmap.context.textAlign = text_align;
    primitives_1._fillstyle(bitmap, colour);
    if (bg !== -1) {
        var length_1 = text_length(f, s);
        var height = text_height(f);
        switch (text_align) {
            case "center":
                primitives_1.rectfill(bitmap, x - length_1 / 2, y, x - length_1 / 2 + length_1, y + height * 1.2, bg);
                break;
            case "right":
                primitives_1.rectfill(bitmap, x - length_1, y, x - length_1 + length_1, y + height * 1.2, bg);
                break;
            case "left":
            default:
                primitives_1.rectfill(bitmap, x, y, x + length_1, y + height * 1.2, bg);
                break;
        }
    }
    primitives_1._fillstyle(bitmap, colour);
    bitmap.context.fillText(s, x, y + f.size);
}
//# sourceMappingURL=font.js.map