"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GmPlayer = void 0;
var GM_INSTRUMENTS = [];
var GmPlayer = (function () {
    function GmPlayer() {
        this.context = new AudioContext();
        this.op1 = this.context.createOscillator();
        this.op2 = this.context.createOscillator();
        this.op1Ratio = 1.0;
        this.op2Ratio = 1.0;
        this.gain = this.context.createGain();
        this.gain.connect(this.context.destination);
    }
    GmPlayer.prototype.programChange = function (instrument) {
        var preset = GM_INSTRUMENTS[instrument];
        if (!preset) {
            return;
        }
        this.changeInstrument(preset);
    };
    GmPlayer.prototype.changeInstrument = function (preset) {
        this.op1.disconnect();
        this.op1.type = preset.op1Type;
        this.op2.disconnect();
        this.op2.type = preset.op2Type;
        this.op1Ratio = preset.op1Ratio;
        this.op2Ratio = preset.op2Ratio;
        this.gain.gain.value = preset.gain;
        switch (preset.op1Dest) {
            case "op2":
                this.op1.connect(this.op2);
                break;
            case "out":
            default:
                this.op1.connect(this.gain);
                break;
        }
        switch (preset.op2Dest) {
            case "op1":
                this.op2.connect(this.op1);
                break;
            case "out":
            default:
                this.op1.connect(this.gain);
                break;
        }
    };
    GmPlayer.prototype.play = function (freq) {
        this.op1.frequency.value = freq * this.op1Ratio;
        this.op2.frequency.value = freq * this.op2Ratio;
    };
    GmPlayer.prototype.stop = function (freq) {
        this.op1.frequency.value = freq * this.op1Ratio;
        this.op2.frequency.value = freq * this.op2Ratio;
    };
    return GmPlayer;
}());
exports.GmPlayer = GmPlayer;
//# sourceMappingURL=gmPlayer.js.map