import { BITMAP, FONT } from "./types";
export declare const gfx_driver: {
    id: number;
    name: string;
    desc: string;
    ascii_name: string;
    w: number;
    h: number;
    linear: boolean;
    bank_size: number;
    vid_mem: number;
    vid_phys_base: number;
    windowed: boolean;
};
export declare let SCREEN_W: number;
export declare let SCREEN_H: number;
export declare function set_color_depth(depth: number): number;
export declare function get_color_depth(): number;
export declare function request_refresh_rate(rate: number): void;
export declare function get_refresh_rate(): number;
export declare function get_gfx_mode_list(card: number): number[][];
export declare function destroy_gfx_mode_list(mode_list: number[]): void;
export declare function set_gfx_mode(card: number, w: number, h: number, v_w?: number, v_h?: number): number;
export declare const GFX_TEXT = -1;
export declare const GFX_AUTODETECT = 0;
export declare const GFX_AUTODETECT_FULLSCREEN = 1;
export declare const GFX_AUTODETECT_WINDOWED = 2;
export declare const GFX_SAFE = 3;
export declare function set_display_switch_mode(mode: number): number;
export declare const SWITCH_NONE = 0;
export declare const SWITCH_PAUSE = 1;
export declare const SWITCH_AMNESIA = 2;
export declare const SWITCH_BACKGROUND = 3;
export declare const SWITCH_BACKAMNESIA = 4;
export declare function set_display_switch_callback(dir: number, cb: () => void): number;
export declare const SWITCH_IN = 0;
export declare const SWITCH_OUT = 1;
export declare function remove_display_switch_callback(cb: () => void): void;
export declare function get_display_switch_mode(): number;
export declare function is_windowed_mode(): boolean;
export declare const GFX_CAN_SCROLL = 1;
export declare const GFX_CAN_TRIPLE_BUFFER = 2;
export declare const GFX_HW_CURSOR = 4;
export declare const GFX_HW_HLINE = 8;
export declare const GFX_HW_HLINE_XOR = 16;
export declare const GFX_HW_HLINE_SOLID_PATTERN = 32;
export declare const GFX_HW_HLINE_COPY_PATTERN = 64;
export declare const GFX_HW_FILL = 128;
export declare const GFX_HW_FILL_XOR = 256;
export declare const GFX_HW_FILL_SOLID_PATTERN = 512;
export declare const GFX_HW_FILL_COPY_PATTERN = 1024;
export declare const GFX_HW_LINE = 2048;
export declare const GFX_HW_LINE_XOR = 4096;
export declare const GFX_HW_TRIANGLE = 8192;
export declare const GFX_HW_TRIANGLE_XOR = 16384;
export declare const GFX_HW_GLYPH = 32768;
export declare const GFX_HW_VRAM_BLIT = 65536;
export declare const GFX_HW_VRAM_BLIT_MASKED = 131072;
export declare const GFX_HW_MEM_BLIT = 262144;
export declare const GFX_HW_MEM_BLIT_MASKED = 524288;
export declare const GFX_HW_SYS_TO_VRAM_BLIT = 1048576;
export declare const GFX_HW_SYS_TO_VRAM_BLIT_MASKED = 2097152;
export declare const GFX_SYSTEM_CURSOR = 4194304;
export declare const GFX_HW_VRAM_STRETCH_BLIT = 8388608;
export declare const GFX_HW_VRAM_STRETCH_BLIT_MASKED = 16777216;
export declare const GFX_HW_SYS_STRETCH_BLIT = 33554432;
export declare const GFX_HW_SYS_STRETCH_BLIT_MASKED = 67108864;
export declare const gfx_capabilities: number;
export declare function enable_triple_buffer(): number;
export declare function scroll_screen(x: number, y: number): void;
export declare function request_scroll(x: number, y: number): void;
export declare function poll_scroll(): void;
export declare function show_video_bitmap(bmp: BITMAP | undefined): void;
export declare function request_video_bitmap(bmp: BITMAP | undefined): BITMAP | undefined;
export declare function vsync(): void;
export declare let _gfx_installed: boolean;
export declare let font: FONT;
