"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GFX_SYSTEM_CURSOR = exports.GFX_HW_SYS_TO_VRAM_BLIT_MASKED = exports.GFX_HW_SYS_TO_VRAM_BLIT = exports.GFX_HW_MEM_BLIT_MASKED = exports.GFX_HW_MEM_BLIT = exports.GFX_HW_VRAM_BLIT_MASKED = exports.GFX_HW_VRAM_BLIT = exports.GFX_HW_GLYPH = exports.GFX_HW_TRIANGLE_XOR = exports.GFX_HW_TRIANGLE = exports.GFX_HW_LINE_XOR = exports.GFX_HW_LINE = exports.GFX_HW_FILL_COPY_PATTERN = exports.GFX_HW_FILL_SOLID_PATTERN = exports.GFX_HW_FILL_XOR = exports.GFX_HW_FILL = exports.GFX_HW_HLINE_COPY_PATTERN = exports.GFX_HW_HLINE_SOLID_PATTERN = exports.GFX_HW_HLINE_XOR = exports.GFX_HW_HLINE = exports.GFX_HW_CURSOR = exports.GFX_CAN_TRIPLE_BUFFER = exports.GFX_CAN_SCROLL = exports.is_windowed_mode = exports.get_display_switch_mode = exports.remove_display_switch_callback = exports.SWITCH_OUT = exports.SWITCH_IN = exports.set_display_switch_callback = exports.SWITCH_BACKAMNESIA = exports.SWITCH_BACKGROUND = exports.SWITCH_AMNESIA = exports.SWITCH_PAUSE = exports.SWITCH_NONE = exports.set_display_switch_mode = exports.GFX_SAFE = exports.GFX_AUTODETECT_WINDOWED = exports.GFX_AUTODETECT_FULLSCREEN = exports.GFX_AUTODETECT = exports.GFX_TEXT = exports.set_gfx_mode = exports.destroy_gfx_mode_list = exports.get_gfx_mode_list = exports.get_refresh_rate = exports.request_refresh_rate = exports.get_color_depth = exports.set_color_depth = exports.SCREEN_H = exports.SCREEN_W = exports.gfx_driver = void 0;
exports.font = exports._gfx_installed = exports.vsync = exports.request_video_bitmap = exports.show_video_bitmap = exports.poll_scroll = exports.request_scroll = exports.scroll_screen = exports.enable_triple_buffer = exports.gfx_capabilities = exports.GFX_HW_SYS_STRETCH_BLIT_MASKED = exports.GFX_HW_SYS_STRETCH_BLIT = exports.GFX_HW_VRAM_STRETCH_BLIT_MASKED = exports.GFX_HW_VRAM_STRETCH_BLIT = void 0;
var allegro_1 = require("./allegro");
var debug_1 = require("./debug");
var primitives_1 = require("./primitives");
var sprites_1 = require("./sprites");
var bitmap_1 = require("./bitmap");
var config_1 = require("./config");
exports.gfx_driver = {
    id: 0,
    name: "No Graphics",
    desc: "No Graphics",
    ascii_name: "No Graphics",
    w: 0,
    h: 0,
    linear: false,
    bank_size: 0,
    vid_mem: 0,
    vid_phys_base: 0,
    windowed: true,
};
exports.SCREEN_W = 0;
exports.SCREEN_H = 0;
function set_color_depth(depth) {
    void depth;
    return 0;
}
exports.set_color_depth = set_color_depth;
function get_color_depth() {
    return 32;
}
exports.get_color_depth = get_color_depth;
function request_refresh_rate(rate) {
    void rate;
}
exports.request_refresh_rate = request_refresh_rate;
function get_refresh_rate() {
    return 60;
}
exports.get_refresh_rate = get_refresh_rate;
function get_gfx_mode_list(card) {
    void card;
    return [[0, 0, 0]];
}
exports.get_gfx_mode_list = get_gfx_mode_list;
function destroy_gfx_mode_list(mode_list) {
    void mode_list;
}
exports.destroy_gfx_mode_list = destroy_gfx_mode_list;
function set_gfx_mode(card, w, h, v_w, v_h) {
    if (v_w === void 0) { v_w = 0; }
    if (v_h === void 0) { v_h = 0; }
    void v_w;
    void v_h;
    bitmap_1.screen.context.imageSmoothingEnabled = false;
    exports.SCREEN_W = w;
    exports.SCREEN_H = h;
    bitmap_1.screen.canvas.width = w;
    bitmap_1.screen.canvas.height = h;
    bitmap_1.screen.w = w;
    bitmap_1.screen.h = h;
    bitmap_1.screen.ready = true;
    primitives_1.clear_to_color(bitmap_1.screen, allegro_1.makecol(0, 0, 0));
    exports.gfx_driver.name = "Browser Graphics";
    exports.gfx_driver.desc = "Browser Graphics";
    exports.gfx_driver.ascii_name = "Browser Graphics";
    exports.gfx_driver.w = window.outerWidth;
    exports.gfx_driver.h = window.outerHeight;
    exports.font = { element: null, file: "", name: "Monospace", size: 12, type: "fnt" };
    exports._gfx_installed = true;
    debug_1.log("Graphics mode set to " + w + " x " + h);
    if (card === exports.GFX_AUTODETECT_FULLSCREEN) {
        var requestFullscreen_1 = function () {
            void bitmap_1.screen.canvas.requestFullscreen();
            bitmap_1.screen.canvas.removeEventListener("click", requestFullscreen_1);
        };
        bitmap_1.screen.canvas.addEventListener("click", requestFullscreen_1);
    }
    else if (card === exports.GFX_TEXT) {
        bitmap_1.screen.canvas.width = 0;
        bitmap_1.screen.canvas.height = 0;
        bitmap_1.screen.w = 0;
        bitmap_1.screen.h = 0;
    }
    return 0;
}
exports.set_gfx_mode = set_gfx_mode;
exports.GFX_TEXT = -1;
exports.GFX_AUTODETECT = 0;
exports.GFX_AUTODETECT_FULLSCREEN = 1;
exports.GFX_AUTODETECT_WINDOWED = 2;
exports.GFX_SAFE = 3;
function set_display_switch_mode(mode) {
    _switch_in_callbacks.length = 0;
    _switch_out_callbacks.length = 0;
    _switch_mode = mode;
    switch (mode) {
        case exports.SWITCH_AMNESIA:
        case exports.SWITCH_PAUSE:
            bitmap_1.screen.canvas.addEventListener("pointerleave", function () {
                config_1._set_loop_interval(-1);
            });
            bitmap_1.screen.canvas.addEventListener("pointerenter", function () {
                config_1._set_loop_interval(window.setInterval(allegro_1._uberloop, 16.6));
            });
            return 0;
        case exports.SWITCH_NONE:
            return -1;
        case exports.SWITCH_BACKAMNESIA:
        case exports.SWITCH_BACKGROUND:
        default:
            return 0;
    }
}
exports.set_display_switch_mode = set_display_switch_mode;
exports.SWITCH_NONE = 0;
exports.SWITCH_PAUSE = 1;
exports.SWITCH_AMNESIA = 2;
exports.SWITCH_BACKGROUND = 3;
exports.SWITCH_BACKAMNESIA = 4;
var _switch_mode = exports.SWITCH_PAUSE;
function set_display_switch_callback(dir, cb) {
    if (_switch_in_callbacks.length + _switch_out_callbacks.length >= 8) {
        return -1;
    }
    if (dir === exports.SWITCH_IN) {
        _switch_in_callbacks.push(cb);
    }
    else if (dir === exports.SWITCH_OUT) {
        _switch_out_callbacks.push(cb);
    }
    return 0;
}
exports.set_display_switch_callback = set_display_switch_callback;
var _switch_in_callbacks = [];
var _switch_out_callbacks = [];
exports.SWITCH_IN = 0;
exports.SWITCH_OUT = 1;
function remove_display_switch_callback(cb) {
    var in_index = _switch_in_callbacks.findIndex(function (proc) { return proc === cb; });
    var out_index = _switch_out_callbacks.findIndex(function (proc) { return proc === cb; });
    if (in_index !== -1) {
        _switch_in_callbacks.splice(in_index, 1);
    }
    if (out_index !== -1) {
        _switch_in_callbacks.splice(out_index, 1);
    }
}
exports.remove_display_switch_callback = remove_display_switch_callback;
function get_display_switch_mode() {
    return _switch_mode;
}
exports.get_display_switch_mode = get_display_switch_mode;
function is_windowed_mode() {
    return !document.fullscreenElement;
}
exports.is_windowed_mode = is_windowed_mode;
exports.GFX_CAN_SCROLL = 0x00000001;
exports.GFX_CAN_TRIPLE_BUFFER = 0x00000002;
exports.GFX_HW_CURSOR = 0x00000004;
exports.GFX_HW_HLINE = 0x00000008;
exports.GFX_HW_HLINE_XOR = 0x00000010;
exports.GFX_HW_HLINE_SOLID_PATTERN = 0x00000020;
exports.GFX_HW_HLINE_COPY_PATTERN = 0x00000040;
exports.GFX_HW_FILL = 0x00000080;
exports.GFX_HW_FILL_XOR = 0x00000100;
exports.GFX_HW_FILL_SOLID_PATTERN = 0x00000200;
exports.GFX_HW_FILL_COPY_PATTERN = 0x00000400;
exports.GFX_HW_LINE = 0x00000800;
exports.GFX_HW_LINE_XOR = 0x00001000;
exports.GFX_HW_TRIANGLE = 0x00002000;
exports.GFX_HW_TRIANGLE_XOR = 0x00004000;
exports.GFX_HW_GLYPH = 0x00008000;
exports.GFX_HW_VRAM_BLIT = 0x00010000;
exports.GFX_HW_VRAM_BLIT_MASKED = 0x00020000;
exports.GFX_HW_MEM_BLIT = 0x00040000;
exports.GFX_HW_MEM_BLIT_MASKED = 0x00080000;
exports.GFX_HW_SYS_TO_VRAM_BLIT = 0x00100000;
exports.GFX_HW_SYS_TO_VRAM_BLIT_MASKED = 0x00200000;
exports.GFX_SYSTEM_CURSOR = 0x00400000;
exports.GFX_HW_VRAM_STRETCH_BLIT = 0x00800000;
exports.GFX_HW_VRAM_STRETCH_BLIT_MASKED = 0x01000000;
exports.GFX_HW_SYS_STRETCH_BLIT = 0x02000000;
exports.GFX_HW_SYS_STRETCH_BLIT_MASKED = 0x04000000;
exports.gfx_capabilities = exports.GFX_HW_CURSOR |
    exports.GFX_HW_HLINE |
    exports.GFX_HW_FILL |
    exports.GFX_HW_LINE |
    exports.GFX_HW_TRIANGLE |
    exports.GFX_HW_VRAM_BLIT |
    exports.GFX_HW_VRAM_BLIT |
    exports.GFX_HW_MEM_BLIT |
    exports.GFX_SYSTEM_CURSOR |
    exports.GFX_HW_SYS_STRETCH_BLIT;
function enable_triple_buffer() {
    return 0;
}
exports.enable_triple_buffer = enable_triple_buffer;
function scroll_screen(x, y) {
    void x;
    void y;
}
exports.scroll_screen = scroll_screen;
function request_scroll(x, y) {
    void x;
    void y;
}
exports.request_scroll = request_scroll;
function poll_scroll() {
}
exports.poll_scroll = poll_scroll;
function show_video_bitmap(bmp) {
    if (!bmp || bmp.w !== bitmap_1.screen.w || bmp.h !== bitmap_1.screen.h) {
        return;
    }
    sprites_1.draw_sprite(bitmap_1.screen, bmp, 0, 0);
}
exports.show_video_bitmap = show_video_bitmap;
function request_video_bitmap(bmp) {
    return bmp;
}
exports.request_video_bitmap = request_video_bitmap;
function vsync() {
}
exports.vsync = vsync;
exports._gfx_installed = false;
//# sourceMappingURL=graphics.js.map