export declare const keyboard_driver: {
    id: number;
    name: string;
    desc: string;
    ascii_name: string;
};
export declare function install_keyboard(enable_keys?: number[]): number;
export declare function remove_keyboard(): number;
export declare function install_keyboard_hooks(keypressed: () => void, readkey: () => void): void;
export declare function poll_keyboard(): number;
export declare function keyboard_needs_poll(): boolean;
export declare const key: boolean[];
export declare const key_buffer: number[];
export declare let key_shifts: number;
export declare function keypressed(): boolean;
export declare function readkey(): Promise<number>;
export declare function ureadkey(scancode: number): number;
export declare function scancode_to_ascii(scancode: number): number;
export declare function scancode_to_name(scancode: number): number;
export declare function simulate_keypress(key: number): void;
export declare function simulate_ukeypress(key: number, scancode: number): void;
export declare function keyboard_callback(key: number): void;
export declare function keyboard_ucallback(key: number, scancode: number): void;
export declare function keyboard_lowlevel_callback(key: number): void;
export declare function set_leds(leds: number): void;
export declare function set_keyboard_rate(delay: number, repeat: number): void;
export declare function clear_keybuf(): void;
export declare const three_finger_flag = false;
export declare const key_led_flag = false;
export declare const KEY_0 = 48, KEY_0_PAD = 96, KEY_1 = 49, KEY_1_PAD = 97, KEY_2 = 50, KEY_2_PAD = 98, KEY_3 = 51, KEY_3_PAD = 99, KEY_4 = 52, KEY_4_PAD = 100, KEY_5 = 53, KEY_5_PAD = 101, KEY_6 = 54, KEY_6_PAD = 102, KEY_7 = 55, KEY_7_PAD = 103, KEY_8 = 56, KEY_8_PAD = 104, KEY_9 = 57, KEY_9_PAD = 105, KEY_A = 65, KEY_ALT = 18, KEY_ALTGR = 18, KEY_ASTERISK = 106, KEY_B = 66, KEY_BACKSLASH = 220, KEY_BACKSPACE = 8, KEY_C = 67, KEY_CAPSLOCK = 20, KEY_CLOSEBRACE = 221, KEY_COLON = 186, KEY_COMMA = 188, KEY_D = 68, KEY_DEL = 46, KEY_DOWN = 40, KEY_E = 69, KEY_END = 35, KEY_ENTER = 13, KEY_ENTER_PAD = 13, KEY_EQUALS = 187, KEY_EQUALS_PAD = 12, KEY_ESC = 27, KEY_F = 70, KEY_F1 = 112, KEY_F10 = 121, KEY_F11 = 122, KEY_F12 = 123, KEY_F2 = 113, KEY_F3 = 114, KEY_F4 = 115, KEY_F5 = 116, KEY_F6 = 117, KEY_F7 = 118, KEY_F8 = 119, KEY_F9 = 120, KEY_G = 71, KEY_H = 72, KEY_HOME = 36, KEY_I = 73, KEY_INSERT = 45, KEY_J = 74, KEY_K = 75, KEY_L = 76, KEY_LCONTROL = 17, KEY_LEFT = 37, KEY_LSHIFT = 16, KEY_LWIN = 91, KEY_M = 77, KEY_MAX = 223, KEY_MENU = 93, KEY_MINUS = 189, KEY_MINUS_PAD = 109, KEY_N = 78, KEY_NUMLOCK = 144, KEY_O = 79, KEY_OPENBRACE = 219, KEY_P = 80, KEY_PAUSE = 19, KEY_PGDN = 34, KEY_PGUP = 33, KEY_PLUS_PAD = 107, KEY_PRTSCR = 44, KEY_Q = 81, KEY_QUOTE = 222, KEY_R = 82, KEY_RCONTROL = 17, KEY_RIGHT = 39, KEY_RSHIFT = 16, KEY_RWIN = 92, KEY_S = 83, KEY_SCRLOCK = 157, KEY_SLASH = 191, KEY_SLASH_PAD = 111, KEY_SPACE = 32, KEY_STOP = 190, KEY_T = 84, KEY_TAB = 9, KEY_TILDE = 192, KEY_U = 85, KEY_UP = 38, KEY_V = 86, KEY_W = 87, KEY_X = 88, KEY_Y = 89, KEY_Z = 90;
export declare const KB_ACCENT1_FLAG = 4096, KB_ACCENT2_FLAG = 8192, KB_ACCENT3_FLAG = 16384, KB_ACCENT4_FLAG = 32768, KB_ALT_FLAG = 4, KB_CAPSLOCK_FLAG = 1024, KB_COMMAND_FLAG = 64, KB_CTRL_FLAG = 2, KB_INALTSEQ_FLAG = 2048, KB_LWIN_FLAG = 8, KB_MENU_FLAG = 32, KB_NUMLOCK_FLAG = 512, KB_RWIN_FLAG = 16, KB_SCROLOCK_FLAG = 256, KB_SHIFT_FLAG = 1;
export declare let _keyboard_installed: boolean;
export declare const _default_enabled_keys: number[];
export declare function _keyboard_loop(): void;
