import { MIDI } from "./types";
export declare const midi_driver: {
    id: number;
    name: string;
    description: string;
    ascii_name: string;
};
export declare function load_midi(filename: string): Promise<MIDI | null>;
export declare function destroy_midi(midi: MIDI): void;
export declare function lock_midi(midi: MIDI): void;
export declare function play_midi(midi: MIDI | null, loop: boolean): void;
export declare function play_looped_midi(midi: MIDI, loop_start: number, loop_end: number): number;
export declare function stop_midi(): void;
export declare function midi_pause(): void;
export declare function midi_resume(): void;
export declare function midi_seek(target: number): void;
export declare function get_midi_length(midi: MIDI): number;
export declare function midi_out(data: string[], length: number): void;
export declare function load_midi_patches(): void;
export declare const midi_pos = 0;
export declare const midi_time = 0;
export declare let midi_loop_start: number;
export declare let midi_loop_end: number;
export declare function midi_msg_callback(msg: number, byte1: number, byte2: number): void;
export declare function load_ibk(filename: string, drums: number): void;
