"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.load_ibk = exports.midi_msg_callback = exports.midi_loop_end = exports.midi_loop_start = exports.midi_time = exports.midi_pos = exports.load_midi_patches = exports.midi_out = exports.get_midi_length = exports.midi_seek = exports.midi_resume = exports.midi_pause = exports.stop_midi = exports.play_looped_midi = exports.play_midi = exports.lock_midi = exports.destroy_midi = exports.load_midi = exports.midi_driver = void 0;
var debug_1 = require("./debug");
var midiParser_1 = require("./midiParser");
var _current_midi = null;
exports.midi_driver = {
    id: 0,
    name: "Browser MIDI",
    description: "Browser MIDI",
    ascii_name: "Browser MIDI",
};
function load_midi(filename) {
    return __awaiter(this, void 0, void 0, function () {
        var fileData, data, midi;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    debug_1.log("Loading midi " + filename + "...");
                    return [4, fetch(filename)
                            .then(function (response) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                            return [2, response.arrayBuffer()];
                        }); }); })
                            .then(function (buffer) { return buffer; })];
                case 1:
                    fileData = _a.sent();
                    data = midiParser_1.parseMidi(fileData);
                    if (!data) {
                        return [2, null];
                    }
                    debug_1.log("MIDI " + filename + " loaded!");
                    midi = {
                        file: filename,
                        ready: true,
                        type: "midi",
                        data: data,
                    };
                    return [2, midi];
            }
        });
    });
}
exports.load_midi = load_midi;
function destroy_midi(midi) {
    void midi;
}
exports.destroy_midi = destroy_midi;
function lock_midi(midi) {
    void midi;
}
exports.lock_midi = lock_midi;
function play_midi(midi, loop) {
    void loop;
    if (_current_midi) {
    }
    if (midi) {
        _current_midi = midi;
    }
}
exports.play_midi = play_midi;
function play_looped_midi(midi, loop_start, loop_end) {
    void midi;
    exports.midi_loop_start = loop_start;
    exports.midi_loop_end = loop_end;
    return 0;
}
exports.play_looped_midi = play_looped_midi;
function stop_midi() {
    play_midi(null, false);
}
exports.stop_midi = stop_midi;
function midi_pause() {
    if (_current_midi) {
    }
}
exports.midi_pause = midi_pause;
function midi_resume() {
    if (_current_midi) {
    }
}
exports.midi_resume = midi_resume;
function midi_seek(target) {
    if (_current_midi) {
        void target;
    }
}
exports.midi_seek = midi_seek;
function get_midi_length(midi) {
    void midi;
    return 0;
}
exports.get_midi_length = get_midi_length;
function midi_out(data, length) {
    void data;
    void length;
}
exports.midi_out = midi_out;
function load_midi_patches() {
}
exports.load_midi_patches = load_midi_patches;
exports.midi_pos = 0;
exports.midi_time = 0;
exports.midi_loop_start = 0;
exports.midi_loop_end = 0;
function midi_msg_callback(msg, byte1, byte2) {
    void msg;
    void byte1;
    void byte2;
}
exports.midi_msg_callback = midi_msg_callback;
function load_ibk(filename, drums) {
    void filename;
    void drums;
}
exports.load_ibk = load_ibk;
//# sourceMappingURL=midi.js.map