import { BITMAP } from "./types";
export declare const MOUSE_CURSOR_NONE = 0;
export declare const MOUSE_CURSOR_ALLEGRO = 1;
export declare const MOUSE_CURSOR_ARROW = 2;
export declare const MOUSE_CURSOR_BUSY = 3;
export declare const MOUSE_CURSOR_QUESTION = 4;
export declare const MOUSE_CURSOR_EDIT = 5;
export declare const AL_NUM_MOUSE_CURSORS = 6;
interface MOUSE_DRIVER {
    id: number;
    name: string;
    desc: string;
    ascii_name: string;
}
export declare const MOUSEDRV_AUTODETECT = -1;
export declare const MOUSEDRV_NONE = 0;
export declare const mouse_driver: MOUSE_DRIVER;
export declare function install_mouse(menu?: boolean): number;
export declare function remove_mouse(): number;
export declare function poll_mouse(): void;
export declare function mouse_needs_poll(): boolean;
export declare function enable_hardware_cursor(): void;
export declare function disable_hardware_cursor(): void;
export declare function select_mouse_cursor(cursor: number): void;
export declare function set_mouse_cursor_bitmap(cursor: number, bmp: BITMAP | null): void;
export declare let mouse_x: number;
export declare let mouse_y: number;
export declare let mouse_z: number;
export declare const mouse_w = -1;
export declare let mouse_b: number;
export declare const mouse_sprite: BITMAP | null;
export declare function show_mouse(bmp: BITMAP | null): number;
export declare function scare_mouse(): number;
export declare function scare_mouse_area(x: number, y: number, w: number, h: number): void;
export declare function show_os_cursor(cursor: number): void;
export declare const freeze_mouse_flag = false;
export declare function position_mouse(x: number, y: number): void;
export declare function position_mouse_z(z: number): void;
export declare function set_mouse_range(x1: number, y1: number, x2: number, y2: number): void;
export declare function set_mouse_speed(xspeed: number, yspeed: number): void;
export declare function set_mouse_sprite(sprite: BITMAP | null): void;
export declare function set_mouse_sprite_focus(x: number, y: number): void;
export declare function get_mouse_mickeys(mickeyx: number, mickeyy: number): void;
export declare function mouse_callback(flags: number): void;
export declare let mouse_mx: number;
export declare let mouse_my: number;
export declare let mouse_mz: number;
export declare let _mouse_installed: boolean;
export declare let _last_mouse_x: number;
export declare let _last_mouse_y: number;
export declare let _last_mouse_z: number;
export declare const _menu = false;
export declare let _menu_supress: boolean;
export declare function _mouse_loop(): void;
export declare function _mouse_loop_reset(): void;
export declare function _mousemenu(e: MouseEvent): void;
export declare function _mouseup(e: MouseEvent): void;
export declare function _mousedown(e: MouseEvent): void;
export declare function _mousemove(e: MouseEvent): void;
export declare function _mousewheel(e: WheelEvent): void;
export {};
