"use strict";
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports._mouseup = exports._mousemenu = exports._mouse_loop_reset = exports._mouse_loop = exports._menu_supress = exports._menu = exports._last_mouse_z = exports._last_mouse_y = exports._last_mouse_x = exports._mouse_installed = exports.mouse_mz = exports.mouse_my = exports.mouse_mx = exports.mouse_callback = exports.get_mouse_mickeys = exports.set_mouse_sprite_focus = exports.set_mouse_sprite = exports.set_mouse_speed = exports.set_mouse_range = exports.position_mouse_z = exports.position_mouse = exports.freeze_mouse_flag = exports.show_os_cursor = exports.scare_mouse_area = exports.scare_mouse = exports.show_mouse = exports.mouse_sprite = exports.mouse_b = exports.mouse_w = exports.mouse_z = exports.mouse_y = exports.mouse_x = exports.set_mouse_cursor_bitmap = exports.select_mouse_cursor = exports.disable_hardware_cursor = exports.enable_hardware_cursor = exports.mouse_needs_poll = exports.poll_mouse = exports.remove_mouse = exports.install_mouse = exports.mouse_driver = exports.MOUSEDRV_NONE = exports.MOUSEDRV_AUTODETECT = exports.AL_NUM_MOUSE_CURSORS = exports.MOUSE_CURSOR_EDIT = exports.MOUSE_CURSOR_QUESTION = exports.MOUSE_CURSOR_BUSY = exports.MOUSE_CURSOR_ARROW = exports.MOUSE_CURSOR_ALLEGRO = exports.MOUSE_CURSOR_NONE = void 0;
exports._mousewheel = exports._mousemove = exports._mousedown = void 0;
var debug_1 = require("./debug");
var bitmap_1 = require("./bitmap");
var sprites_1 = require("./sprites");
exports.MOUSE_CURSOR_NONE = 0;
exports.MOUSE_CURSOR_ALLEGRO = 1;
exports.MOUSE_CURSOR_ARROW = 2;
exports.MOUSE_CURSOR_BUSY = 3;
exports.MOUSE_CURSOR_QUESTION = 4;
exports.MOUSE_CURSOR_EDIT = 5;
exports.AL_NUM_MOUSE_CURSORS = 6;
exports.MOUSEDRV_AUTODETECT = -1;
exports.MOUSEDRV_NONE = 0;
exports.mouse_driver = {
    id: exports.MOUSEDRV_NONE,
    name: "",
    desc: "",
    ascii_name: "No mouse",
};
var _mouse_focus_x = 0;
var _mouse_focus_y = 0;
var _hardware_cursor = false;
var _selected_cursor = exports.MOUSE_CURSOR_ALLEGRO;
var _cursors = (_a = {},
    _a[exports.MOUSE_CURSOR_ALLEGRO] = null,
    _a[exports.MOUSE_CURSOR_ARROW] = null,
    _a[exports.MOUSE_CURSOR_BUSY] = null,
    _a[exports.MOUSE_CURSOR_EDIT] = null,
    _a[exports.MOUSE_CURSOR_NONE] = null,
    _a[exports.MOUSE_CURSOR_QUESTION] = null,
    _a);
function install_mouse(menu) {
    if (menu === void 0) { menu = false; }
    if (exports._mouse_installed) {
        debug_1._allog("Mouse already installed");
        return -1;
    }
    exports.mouse_driver.id = exports.MOUSEDRV_AUTODETECT;
    exports.mouse_driver.name = "Browser Mouse";
    exports.mouse_driver.desc = "Allegro Browser Handler";
    exports.mouse_driver.ascii_name = "Browser Mouse";
    bitmap_1.screen.canvas.addEventListener("mouseup", _mouseup);
    bitmap_1.screen.canvas.addEventListener("mousedown", _mousedown);
    bitmap_1.screen.canvas.addEventListener("mousemove", _mousemove);
    bitmap_1.screen.canvas.addEventListener("wheel", _mousewheel);
    if (menu) {
        exports._menu_supress = true;
    }
    else {
        bitmap_1.screen.canvas.addEventListener("contextmenu", _mousemenu);
        exports._menu_supress = false;
    }
    exports._mouse_installed = true;
    debug_1.log("Mouse installed!");
    return 0;
}
exports.install_mouse = install_mouse;
function remove_mouse() {
    if (!exports._mouse_installed) {
        debug_1._error("You must call install_mouse before remove_mouse");
        return -1;
    }
    bitmap_1.screen.canvas.removeEventListener("mouseup", _mouseup);
    bitmap_1.screen.canvas.removeEventListener("mousedown", _mousedown);
    bitmap_1.screen.canvas.removeEventListener("mousemove", _mousemove);
    bitmap_1.screen.canvas.removeEventListener("wheel", _mousewheel);
    if (exports._menu_supress)
        bitmap_1.screen.canvas.removeEventListener("contextmenu", _mousemenu);
    exports._mouse_installed = false;
    debug_1.log("Mouse removed!");
    return 0;
}
exports.remove_mouse = remove_mouse;
function poll_mouse() {
    _mouse_loop();
}
exports.poll_mouse = poll_mouse;
function mouse_needs_poll() {
    return false;
}
exports.mouse_needs_poll = mouse_needs_poll;
function enable_hardware_cursor() {
    _hardware_cursor = true;
}
exports.enable_hardware_cursor = enable_hardware_cursor;
function disable_hardware_cursor() {
    _hardware_cursor = false;
}
exports.disable_hardware_cursor = disable_hardware_cursor;
function select_mouse_cursor(cursor) {
    _selected_cursor = cursor;
    if (_hardware_cursor) {
        show_os_cursor(cursor);
    }
}
exports.select_mouse_cursor = select_mouse_cursor;
function set_mouse_cursor_bitmap(cursor, bmp) {
    _cursors[cursor] = bmp;
}
exports.set_mouse_cursor_bitmap = set_mouse_cursor_bitmap;
exports.mouse_x = -1;
exports.mouse_y = -1;
exports.mouse_z = -1;
exports.mouse_w = -1;
exports.mouse_b = 0;
exports.mouse_sprite = null;
function show_mouse(bmp) {
    if (!exports._mouse_installed) {
        debug_1._error("You must call install_mouse before show_mouse");
        return -1;
    }
    if (bmp) {
        bitmap_1.screen.canvas.style.cursor = "auto";
    }
    else {
        bitmap_1.screen.canvas.style.cursor = "none";
    }
    return 0;
}
exports.show_mouse = show_mouse;
function scare_mouse() {
    if (!exports._mouse_installed) {
        debug_1._error("You must call install_mouse before hide_mouse");
        return -1;
    }
    bitmap_1.screen.canvas.style.cursor = "none";
    return 0;
}
exports.scare_mouse = scare_mouse;
function scare_mouse_area(x, y, w, h) {
    void x;
    void y;
    void w;
    void h;
}
exports.scare_mouse_area = scare_mouse_area;
function show_os_cursor(cursor) {
    switch (cursor) {
        case exports.MOUSE_CURSOR_ALLEGRO:
            bitmap_1.screen.canvas.style.cursor = "auto";
            break;
        case exports.MOUSE_CURSOR_ARROW:
            bitmap_1.screen.canvas.style.cursor = "move";
            break;
        case exports.MOUSE_CURSOR_BUSY:
            bitmap_1.screen.canvas.style.cursor = "wait";
            break;
        case exports.MOUSE_CURSOR_EDIT:
            bitmap_1.screen.canvas.style.cursor = "crosshair";
            break;
        case exports.MOUSE_CURSOR_NONE:
            bitmap_1.screen.canvas.style.cursor = "auto";
            break;
        case exports.MOUSE_CURSOR_QUESTION:
            bitmap_1.screen.canvas.style.cursor = "help";
            break;
        default:
            bitmap_1.screen.canvas.style.cursor = "auto";
            break;
    }
}
exports.show_os_cursor = show_os_cursor;
exports.freeze_mouse_flag = false;
function position_mouse(x, y) {
    exports.mouse_x = x;
    exports.mouse_y = y;
}
exports.position_mouse = position_mouse;
function position_mouse_z(z) {
    exports.mouse_z = z;
}
exports.position_mouse_z = position_mouse_z;
function set_mouse_range(x1, y1, x2, y2) {
    void x1;
    void y1;
    void x2;
    void y2;
}
exports.set_mouse_range = set_mouse_range;
function set_mouse_speed(xspeed, yspeed) {
    void xspeed;
    void yspeed;
}
exports.set_mouse_speed = set_mouse_speed;
function set_mouse_sprite(sprite) {
    _cursors[exports.MOUSE_CURSOR_ALLEGRO] = sprite;
}
exports.set_mouse_sprite = set_mouse_sprite;
function set_mouse_sprite_focus(x, y) {
    _mouse_focus_x = x;
    _mouse_focus_y = y;
}
exports.set_mouse_sprite_focus = set_mouse_sprite_focus;
function get_mouse_mickeys(mickeyx, mickeyy) {
    void mickeyx;
    void mickeyy;
}
exports.get_mouse_mickeys = get_mouse_mickeys;
function mouse_callback(flags) {
    void flags;
}
exports.mouse_callback = mouse_callback;
exports.mouse_mx = 0;
exports.mouse_my = 0;
exports.mouse_mz = 0;
exports._mouse_installed = false;
exports._last_mouse_x = -1;
exports._last_mouse_y = -1;
exports._last_mouse_z = -1;
exports._menu = false;
exports._menu_supress = false;
function _mouse_loop() {
    if (exports._mouse_installed) {
        exports.mouse_mx = exports.mouse_x - exports._last_mouse_x;
        exports.mouse_my = exports.mouse_y - exports._last_mouse_y;
        exports.mouse_mz = exports.mouse_z - exports._last_mouse_z;
    }
}
exports._mouse_loop = _mouse_loop;
function _mouse_loop_reset() {
    if (exports._mouse_installed) {
        exports.mouse_mx = 0;
        exports.mouse_my = 0;
        exports.mouse_mz = 0;
        exports._last_mouse_x = exports.mouse_x;
        exports._last_mouse_y = exports.mouse_y;
        exports._last_mouse_z = exports.mouse_z;
        var cursor = _cursors[_selected_cursor];
        if (cursor && !_hardware_cursor) {
            sprites_1.draw_sprite(bitmap_1.screen, cursor, exports.mouse_x - _mouse_focus_x, exports.mouse_y - _mouse_focus_y);
            bitmap_1.screen.canvas.style.cursor = "none";
        }
        else {
            show_os_cursor(_selected_cursor);
        }
    }
}
exports._mouse_loop_reset = _mouse_loop_reset;
function _mousemenu(e) {
    e.preventDefault();
}
exports._mousemenu = _mousemenu;
function _mouseup(e) {
    exports.mouse_b &= ~(1 << e.button);
    e.preventDefault();
}
exports._mouseup = _mouseup;
function _mousedown(e) {
    exports.mouse_b |= 1 << e.button;
    e.preventDefault();
}
exports._mousedown = _mousedown;
function _mousemove(e) {
    exports.mouse_x = e.offsetX;
    exports.mouse_y = e.offsetY;
    e.preventDefault();
}
exports._mousemove = _mousemove;
function _mousewheel(e) {
    exports.mouse_z += e.deltaY;
    e.preventDefault();
}
exports._mousewheel = _mousewheel;
//# sourceMappingURL=mouse.js.map