"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports._strokestyle = exports._fillstyle = exports.floodfill = exports.spline = exports.calc_spline = exports.arc = exports.do_arc = exports.ellipsefill = exports.ellipse = exports.do_ellipse = exports.circlefill = exports.circle = exports.do_circle = exports.rectfill = exports.rect = exports.polygon = exports.triangle = exports.fastline = exports.line = exports.do_line = exports.hline = exports.vline = exports._getpixel32 = exports._getpixel24 = exports._getpixel16 = exports._getpixel15 = exports._getpixel = exports.getpixel = exports._putpixel32 = exports._putpixel24 = exports._putpixel16 = exports._putpixel15 = exports._putpixel = exports.putpixel = exports.clear_to_color = exports.clear_bitmap = void 0;
var color_1 = require("./color");
var math_1 = require("./math");
function clear_bitmap(bitmap) {
    clear_to_color(bitmap, 0x000000);
}
exports.clear_bitmap = clear_bitmap;
function clear_to_color(bitmap, colour) {
    if (!bitmap) {
        return;
    }
    bitmap.context.clearRect(0, 0, bitmap.w, bitmap.h);
    _fillstyle(bitmap, colour);
    bitmap.context.fillRect(0, 0, bitmap.w, bitmap.h);
}
exports.clear_to_color = clear_to_color;
function putpixel(bmp, x, y, c) {
    if (!bmp) {
        return;
    }
    _fillstyle(bmp, c);
    bmp.context.fillRect(x, y, 1, 1);
}
exports.putpixel = putpixel;
function _putpixel(bmp, x, y, c) {
    putpixel(bmp, x, y, c);
}
exports._putpixel = _putpixel;
function _putpixel15(bmp, x, y, c) {
    putpixel(bmp, x, y, c);
}
exports._putpixel15 = _putpixel15;
function _putpixel16(bmp, x, y, c) {
    putpixel(bmp, x, y, c);
}
exports._putpixel16 = _putpixel16;
function _putpixel24(bmp, x, y, c) {
    putpixel(bmp, x, y, c);
}
exports._putpixel24 = _putpixel24;
function _putpixel32(bmp, x, y, c) {
    putpixel(bmp, x, y, c);
}
exports._putpixel32 = _putpixel32;
function getpixel(bmp, x, y) {
    var _a, _b, _c, _d;
    if (!bmp || x < 0 || y < 0 || x >= bmp.w || y >= bmp.h) {
        return -1;
    }
    var data = bmp.context.getImageData(x, y, 1, 1).data;
    return ((((_a = data[3]) !== null && _a !== void 0 ? _a : 0) << 24) |
        ((((_b = data[0]) !== null && _b !== void 0 ? _b : 0) & 0xff) << 16) |
        ((((_c = data[1]) !== null && _c !== void 0 ? _c : 0) & 0xff) << 8) |
        (((_d = data[2]) !== null && _d !== void 0 ? _d : 0) & 0xff));
}
exports.getpixel = getpixel;
function _getpixel(bmp, x, y) {
    return getpixel(bmp, x, y);
}
exports._getpixel = _getpixel;
function _getpixel15(bmp, x, y) {
    return getpixel(bmp, x, y);
}
exports._getpixel15 = _getpixel15;
function _getpixel16(bmp, x, y) {
    return getpixel(bmp, x, y);
}
exports._getpixel16 = _getpixel16;
function _getpixel24(bmp, x, y) {
    return getpixel(bmp, x, y);
}
exports._getpixel24 = _getpixel24;
function _getpixel32(bmp, x, y) {
    return getpixel(bmp, x, y);
}
exports._getpixel32 = _getpixel32;
function vline(bitmap, x, y1, y2, colour) {
    if (!bitmap) {
        return;
    }
    _fillstyle(bitmap, colour);
    bitmap.context.fillRect(x - 1 / 2, y1, 1, y2 - y1);
}
exports.vline = vline;
function hline(bitmap, x1, y, x2, colour) {
    if (!bitmap) {
        return;
    }
    _fillstyle(bitmap, colour);
    bitmap.context.fillRect(x1, y - 1 / 2, x2 - x1, 1);
}
exports.hline = hline;
function do_line(bitmap, x1, y1, x2, y2, d, proc) {
    void bitmap;
    void x1;
    void y1;
    void x2;
    void y2;
    void d;
    void proc;
}
exports.do_line = do_line;
function line(bitmap, x1, y1, x2, y2, colour) {
    if (!bitmap) {
        return;
    }
    _strokestyle(bitmap, colour);
    bitmap.context.beginPath();
    bitmap.context.moveTo(x1, y1);
    bitmap.context.lineTo(x2, y2);
    bitmap.context.stroke();
}
exports.line = line;
function fastline(bitmap, x1, y1, x2, y2, colour) {
    line(bitmap, x1, y1, x2, y2, colour);
}
exports.fastline = fastline;
function triangle(bitmap, x1, y1, x2, y2, x3, y3, colour) {
    if (!bitmap) {
        return;
    }
    _fillstyle(bitmap, colour);
    bitmap.context.beginPath();
    bitmap.context.moveTo(x1, y1);
    bitmap.context.lineTo(x2, y2);
    bitmap.context.lineTo(x3, y3);
    bitmap.context.closePath();
    bitmap.context.fill();
}
exports.triangle = triangle;
function polygon(bitmap, vertices, points, colour) {
    var _a, _b, _c, _d;
    if (!bitmap) {
        return;
    }
    _fillstyle(bitmap, colour);
    bitmap.context.beginPath();
    for (var c = 0; c < vertices; c += 1) {
        if (c)
            bitmap.context.lineTo((_a = points[c * 2]) !== null && _a !== void 0 ? _a : 0, (_b = points[c * 2 + 1]) !== null && _b !== void 0 ? _b : 0);
        else
            bitmap.context.moveTo((_c = points[c * 2]) !== null && _c !== void 0 ? _c : 0, (_d = points[c * 2 + 1]) !== null && _d !== void 0 ? _d : 0);
    }
    bitmap.context.closePath();
    bitmap.context.fill();
}
exports.polygon = polygon;
function rect(bitmap, x1, y1, x2, y2, colour) {
    if (!bitmap) {
        return;
    }
    _strokestyle(bitmap, colour);
    bitmap.context.strokeRect(x1, y1, x2 - x1, y2 - y1);
}
exports.rect = rect;
function rectfill(bitmap, x1, y1, x2, y2, colour) {
    if (!bitmap) {
        return;
    }
    _fillstyle(bitmap, colour);
    bitmap.context.fillRect(x1, y1, x2 - x1, y2 - y1);
}
exports.rectfill = rectfill;
function do_circle(bmp, x, y, radius, d, proc) {
    void bmp;
    void x;
    void y;
    void radius;
    void d;
    void proc;
}
exports.do_circle = do_circle;
function circle(bitmap, x, y, radius, colour) {
    if (!bitmap) {
        return;
    }
    _strokestyle(bitmap, colour);
    bitmap.context.beginPath();
    bitmap.context.arc(x, y, radius, 0, math_1.PI2);
    bitmap.context.stroke();
}
exports.circle = circle;
function circlefill(bitmap, x, y, radius, colour) {
    if (!bitmap) {
        return;
    }
    _fillstyle(bitmap, colour);
    bitmap.context.beginPath();
    bitmap.context.arc(x, y, radius, 0, math_1.PI2);
    bitmap.context.fill();
}
exports.circlefill = circlefill;
function do_ellipse(bitmap, x, y, rx, ry, d, proc) {
    void bitmap;
    void x;
    void y;
    void rx;
    void ry;
    void d;
    void proc;
}
exports.do_ellipse = do_ellipse;
function ellipse(bitmap, x, y, rx, ry, colour) {
    if (!bitmap) {
        return;
    }
    _strokestyle(bitmap, colour);
    bitmap.context.save();
    bitmap.context.translate(x, y);
    bitmap.context.scale(rx, ry);
    bitmap.context.beginPath();
    bitmap.context.arc(0, 0, 1, 0, math_1.PI2);
    bitmap.context.restore();
    bitmap.context.stroke();
}
exports.ellipse = ellipse;
function ellipsefill(bitmap, x, y, rx, ry, colour) {
    if (!bitmap) {
        return;
    }
    _fillstyle(bitmap, colour);
    bitmap.context.save();
    bitmap.context.translate(x, y);
    bitmap.context.scale(rx, ry);
    bitmap.context.beginPath();
    bitmap.context.arc(0, 0, 1, 0, math_1.PI2);
    bitmap.context.restore();
    bitmap.context.fill();
}
exports.ellipsefill = ellipsefill;
function do_arc(bitmap, x, y, a1, a2, r, d, proc) {
    void bitmap;
    void x;
    void y;
    void a1;
    void a2;
    void r;
    void d;
    void proc;
}
exports.do_arc = do_arc;
function arc(bitmap, x, y, ang1, ang2, r, colour) {
    if (!bitmap) {
        return;
    }
    _strokestyle(bitmap, colour);
    bitmap.context.beginPath();
    if (ang1 > ang2) {
        bitmap.context.arc(x, y, r, math_1.fix_to_rad(ang1), math_1.fix_to_rad(ang2), true);
    }
    else {
        bitmap.context.arc(x, y, r, math_1.fix_to_rad(ang1), math_1.fix_to_rad(ang2), true);
    }
    bitmap.context.stroke();
}
exports.arc = arc;
function calc_spline(points, npts, x, y) {
    void points;
    void npts;
    void x;
    void y;
}
exports.calc_spline = calc_spline;
function spline(bmp, points, color) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    if (!bmp || points.length !== 8) {
        return;
    }
    _strokestyle(bmp, color);
    bmp.context.beginPath();
    for (var i = 0; i < points.length - 1; i += 2) {
        var x_mid = (((_a = points[i]) !== null && _a !== void 0 ? _a : 0) + ((_b = points[i + 2]) !== null && _b !== void 0 ? _b : 0)) / 2;
        var y_mid = (((_c = points[i + 1]) !== null && _c !== void 0 ? _c : 0) + ((_d = points[i + 3]) !== null && _d !== void 0 ? _d : 0)) / 2;
        var cp_x1 = (x_mid + ((_e = points[i]) !== null && _e !== void 0 ? _e : 0)) / 2;
        var cp_x2 = (x_mid + ((_f = points[i + 2]) !== null && _f !== void 0 ? _f : 0)) / 2;
        bmp.context.quadraticCurveTo(cp_x1, (_g = points[i + 1]) !== null && _g !== void 0 ? _g : 0, x_mid, y_mid);
        bmp.context.quadraticCurveTo(cp_x2, (_h = points[i + 3]) !== null && _h !== void 0 ? _h : 0, (_j = points[i + 2]) !== null && _j !== void 0 ? _j : 0, (_k = points[i + 3]) !== null && _k !== void 0 ? _k : 0);
    }
    bmp.context.stroke();
}
exports.spline = spline;
function floodfill(bmp, x, y, color) {
    void bmp;
    void x;
    void y;
    void color;
}
exports.floodfill = floodfill;
function _fillstyle(bitmap, colour) {
    if (!bitmap) {
        return;
    }
    bitmap.context.fillStyle = "rgba(" + color_1.getr(colour) + "," + color_1.getg(colour) + "," + color_1.getb(colour) + "," + (255 - color_1.geta(colour)) / 255 + ")";
}
exports._fillstyle = _fillstyle;
function _strokestyle(bitmap, colour, width) {
    if (width === void 0) { width = 1; }
    if (!bitmap) {
        return;
    }
    bitmap.context.lineWidth = width;
    bitmap.context.strokeStyle = "rgba(" + color_1.getr(colour) + "," + color_1.getg(colour) + "," + color_1.getb(colour) + "," + (255 - color_1.geta(colour)) / 255 + ")";
}
exports._strokestyle = _strokestyle;
//# sourceMappingURL=primitives.js.map