"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.stop_sample = exports.adjust_sample = exports.play_sample = exports.destroy_sample = exports.load_sample = exports.get_volume = exports.set_volume = exports.remove_sound = exports.install_sound = exports.MIDI_DIGMID = exports.MIDI_NONE = exports.MIDI_AUTODETECT = exports.DIGI_NONE = exports.DIGI_AUTODETECT = exports.digi_driver = void 0;
var debug_1 = require("./debug");
var _volume = 1.0;
var _midi_volume = 1.0;
exports.digi_driver = {
    id: 0,
    name: "Browser DIGI",
    desc: "Browser DIGI",
    ascii_name: "Browser DIGI",
};
var _samples = [];
var _context = null;
var _context_gain = null;
exports.DIGI_AUTODETECT = -1;
exports.DIGI_NONE = 0;
exports.MIDI_AUTODETECT = -1;
exports.MIDI_NONE = 0;
exports.MIDI_DIGMID = 1;
function install_sound(digi, midi, cfg_path) {
    void digi;
    void midi;
    void cfg_path;
    _context = new window.AudioContext();
    _context_gain = _context.createGain();
    _context_gain.connect(_context.destination);
    return 0;
}
exports.install_sound = install_sound;
function remove_sound() {
}
exports.remove_sound = remove_sound;
function set_volume(digi_volume, midi_volume) {
    if (digi_volume > 255) {
        _volume = 255;
    }
    else if (digi_volume >= 0) {
        _volume = digi_volume;
    }
    if (midi_volume > 255) {
        _midi_volume = 255;
    }
    else if (midi_volume >= 0) {
        _midi_volume = midi_volume;
    }
    if (_context_gain) {
        _context_gain.gain.value = _volume / 255;
    }
}
exports.set_volume = set_volume;
function get_volume() {
    return { digi_volume: _volume, midi_volume: _midi_volume };
}
exports.get_volume = get_volume;
function load_sample(filename) {
    return __awaiter(this, void 0, void 0, function () {
        var sample, buffer;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!_context || !_context_gain) {
                        throw new Error("Can not load audio without audio context");
                    }
                    debug_1.log("Loading sample " + filename + "...");
                    sample = {
                        file: filename,
                        source: _context.createBufferSource(),
                        gain: _context.createGain(),
                        buffer: null,
                        pan: _context.createStereoPanner(),
                        ready: false,
                        type: "snd",
                    };
                    return [4, fetch(filename)
                            .then(function (response) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                            return [2, response.arrayBuffer()];
                        }); }); })
                            .then(function (buffer) { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                            return [2, _context === null || _context === void 0 ? void 0 : _context.decodeAudioData(buffer)];
                        }); }); })];
                case 1:
                    buffer = _a.sent();
                    if (!buffer) {
                        throw new Error("Could not load sample");
                    }
                    sample.buffer = buffer;
                    sample.pan.connect(sample.gain);
                    sample.gain.connect(_context_gain);
                    sample.ready = true;
                    debug_1.log("Sample " + filename + " loaded!");
                    return [2, sample];
            }
        });
    });
}
exports.load_sample = load_sample;
function destroy_sample(spl) {
    var index = _samples.findIndex(function (s) { return s === spl; });
    if (index !== -1) {
        debug_1.log("Sample destroyed at index " + index);
        spl.source.disconnect();
        _samples.splice(index, 1);
    }
}
exports.destroy_sample = destroy_sample;
function play_sample(sample, vol, pan, freq, loop) {
    if (vol === void 0) { vol = 255; }
    if (pan === void 0) { pan = 127; }
    if (freq === void 0) { freq = 1000; }
    if (loop === void 0) { loop = false; }
    if (!_context) {
        return;
    }
    sample.source = _context.createBufferSource();
    sample.source.buffer = sample.buffer;
    sample.source.connect(sample.pan);
    adjust_sample(sample, vol, pan, freq, loop);
    sample.source.start(0);
}
exports.play_sample = play_sample;
function adjust_sample(sample, vol, pan, freq, loop) {
    sample.pan.pan.value = pan / 127.0 - 1.0;
    sample.gain.gain.value = vol / 255.0;
    sample.source.loop = loop;
    sample.source.playbackRate.value = freq / 1000.0;
}
exports.adjust_sample = adjust_sample;
function stop_sample(sample) {
    sample.source.stop();
}
exports.stop_sample = stop_sample;
//# sourceMappingURL=sample.js.map