"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pivot_scaled_sprite_v_flip = exports.pivot_scaled_sprite = exports.pivot_sprite_v_flip = exports.pivot_sprite = exports.rotate_scaled_sprite_v_flip = exports.rotate_scaled_sprite = exports.rotate_sprite_v_flip = exports.rotate_sprite = exports.draw_character_ex = exports.draw_gouraud_sprite = exports.draw_lit_sprite = exports.draw_trans_sprite = exports.draw_sprite_vh_flip = exports.draw_sprite_h_flip = exports.draw_sprite_v_flip = exports.stretch_sprite = exports.draw_sprite = exports.masked_stretch_blit = exports.masked_blit = exports.stretch_blit = exports.blit = void 0;
var math_1 = require("./math");
function blit(source, dest, source_x, source_y, dest_x, dest_y, width, height) {
    if (!source || !dest) {
        return;
    }
    dest.context.drawImage(source.canvas, source_x, source_y, source.w, source.h, dest_x, dest_y, width, height);
}
exports.blit = blit;
function stretch_blit(source, dest, source_x, source_y, source_width, source_height, dest_x, dest_y, dest_width, dest_height) {
    if (!source || !dest) {
        return;
    }
    dest.context.drawImage(source.canvas, source_x, source_y, source_width, source_height, dest_x, dest_y, dest_width, dest_height);
}
exports.stretch_blit = stretch_blit;
function masked_blit(sprite, dest, source_x, source_y, dest_x, dest_y, width, height) {
    void sprite;
    void dest;
    void source_x;
    void source_y;
    void dest_x;
    void dest_y;
    void width;
    void height;
}
exports.masked_blit = masked_blit;
function masked_stretch_blit(sprite, dest, source_x, source_y, source_w, source_h, dest_x, dest_y, dest_w, dest_h) {
    void sprite;
    void dest;
    void source_x;
    void source_y;
    void source_w;
    void source_h;
    void dest_x;
    void dest_y;
    void dest_w;
    void dest_h;
}
exports.masked_stretch_blit = masked_stretch_blit;
function draw_sprite(bmp, sprite, x, y) {
    if (!sprite || !bmp) {
        return;
    }
    bmp.context.drawImage(sprite.canvas, x, y);
}
exports.draw_sprite = draw_sprite;
function stretch_sprite(bmp, sprite, x, y, w, h) {
    if (!bmp || !sprite) {
        return;
    }
    bmp.context.drawImage(sprite.canvas, x, y, w, h);
}
exports.stretch_sprite = stretch_sprite;
function draw_sprite_v_flip(bmp, sprite, x, y) {
    if (!bmp || !sprite) {
        return;
    }
    bmp.context.save();
    bmp.context.translate(x, y);
    bmp.context.scale(-1, 1);
    bmp.context.translate(-x - sprite.w, -y);
    bmp.context.drawImage(sprite.canvas, x, y);
    bmp.context.restore();
}
exports.draw_sprite_v_flip = draw_sprite_v_flip;
function draw_sprite_h_flip(bmp, sprite, x, y) {
    if (!bmp || !sprite) {
        return;
    }
    bmp.context.save();
    bmp.context.translate(x, y);
    bmp.context.scale(1, -1);
    bmp.context.translate(-x, -y - sprite.h);
    bmp.context.drawImage(sprite.canvas, x, y);
    bmp.context.restore();
}
exports.draw_sprite_h_flip = draw_sprite_h_flip;
function draw_sprite_vh_flip(bmp, sprite, x, y) {
    if (!bmp || !sprite) {
        return;
    }
    bmp.context.save();
    bmp.context.translate(x, y);
    bmp.context.scale(-1, -1);
    bmp.context.translate(-x - sprite.w, -y - sprite.h);
    bmp.context.drawImage(sprite.canvas, x, y);
    bmp.context.restore();
}
exports.draw_sprite_vh_flip = draw_sprite_vh_flip;
function draw_trans_sprite(bmp, sprite, x, y) {
    draw_sprite(bmp, sprite, x, y);
}
exports.draw_trans_sprite = draw_trans_sprite;
function draw_lit_sprite(bmp, sprite, x, y, color) {
    void color;
    draw_sprite(bmp, sprite, x, y);
}
exports.draw_lit_sprite = draw_lit_sprite;
function draw_gouraud_sprite(bmp, sprite, x, y, c1, c2, c3, c4) {
    void c1;
    void c2;
    void c3;
    void c4;
    draw_sprite(bmp, sprite, x, y);
}
exports.draw_gouraud_sprite = draw_gouraud_sprite;
function draw_character_ex(bmp, sprite, x, y, color, bg) {
    void color;
    void bg;
    draw_sprite(bmp, sprite, x, y);
}
exports.draw_character_ex = draw_character_ex;
function rotate_sprite(bmp, sprite, x, y, angle) {
    if (!bmp || !sprite) {
        return;
    }
    var u = sprite.w / 2;
    var v = sprite.h / 2;
    bmp.context.save();
    bmp.context.translate(x + u, y + v);
    bmp.context.rotate(math_1.fix_to_rad(angle));
    bmp.context.translate(-x - u, -y - v);
    bmp.context.drawImage(sprite.canvas, x, y);
    bmp.context.restore();
}
exports.rotate_sprite = rotate_sprite;
function rotate_sprite_v_flip(bmp, sprite, x, y, angle) {
    if (!bmp || !sprite) {
        return;
    }
    var u = sprite.w / 2;
    var v = sprite.h / 2;
    bmp.context.save();
    bmp.context.translate(x + u, y + v);
    bmp.context.rotate(math_1.fix_to_rad(angle));
    bmp.context.translate(-x - u, -y - v);
    bmp.context.translate(x, y);
    bmp.context.scale(-1, 1);
    bmp.context.translate(-x - sprite.w, -y);
    bmp.context.drawImage(sprite.canvas, x, y);
    bmp.context.restore();
}
exports.rotate_sprite_v_flip = rotate_sprite_v_flip;
function rotate_scaled_sprite(bmp, sprite, x, y, angle, scale) {
    if (!bmp || !sprite) {
        return;
    }
    var u = sprite.w / 2;
    var v = sprite.h / 2;
    bmp.context.save();
    bmp.context.translate(x + u, y + v);
    bmp.context.rotate(math_1.fix_to_rad(angle));
    bmp.context.scale(scale, scale);
    bmp.context.translate(-x - u, -y - v);
    bmp.context.drawImage(sprite.canvas, x, y);
    bmp.context.restore();
}
exports.rotate_scaled_sprite = rotate_scaled_sprite;
function rotate_scaled_sprite_v_flip(bmp, sprite, x, y, angle, scale) {
    if (!bmp || !sprite) {
        return;
    }
    var u = sprite.w / 2;
    var v = sprite.h / 2;
    bmp.context.save();
    bmp.context.translate(x + u, y + v);
    bmp.context.rotate(math_1.fix_to_rad(angle));
    bmp.context.scale(scale, scale);
    bmp.context.translate(-x - u, -y - v);
    bmp.context.translate(x, y);
    bmp.context.scale(-1, 1);
    bmp.context.translate(-x - sprite.w, -y);
    bmp.context.drawImage(sprite.canvas, x, y);
    bmp.context.restore();
}
exports.rotate_scaled_sprite_v_flip = rotate_scaled_sprite_v_flip;
function pivot_sprite(bmp, sprite, x, y, cx, cy, angle) {
    if (!bmp || !sprite) {
        return;
    }
    bmp.context.save();
    bmp.context.translate(x, y);
    bmp.context.rotate(math_1.fix_to_rad(angle));
    bmp.context.translate(-cx, -cy);
    bmp.context.drawImage(sprite.canvas, 0, 0);
    bmp.context.restore();
}
exports.pivot_sprite = pivot_sprite;
function pivot_sprite_v_flip(bmp, sprite, x, y, cx, cy, angle) {
    if (!bmp || !sprite) {
        return;
    }
    bmp.context.save();
    bmp.context.translate(x, y);
    bmp.context.rotate(math_1.fix_to_rad(angle));
    bmp.context.translate(-cx, -cy);
    bmp.context.translate(x, y);
    bmp.context.scale(-1, 1);
    bmp.context.translate(-x - sprite.w, -y);
    bmp.context.drawImage(sprite.canvas, 0, 0);
    bmp.context.restore();
}
exports.pivot_sprite_v_flip = pivot_sprite_v_flip;
function pivot_scaled_sprite(bmp, sprite, x, y, cx, cy, angle, scale) {
    if (!bmp || !sprite) {
        return;
    }
    var u = scale * cx;
    var v = scale * cy;
    bmp.context.save();
    bmp.context.translate(x, y);
    bmp.context.rotate(math_1.fix_to_rad(angle));
    bmp.context.translate(-u, -v);
    bmp.context.scale(scale, scale);
    bmp.context.drawImage(sprite.canvas, 0, 0);
    bmp.context.restore();
}
exports.pivot_scaled_sprite = pivot_scaled_sprite;
function pivot_scaled_sprite_v_flip(bmp, sprite, x, y, cx, cy, angle, scale) {
    if (!bmp || !sprite) {
        return;
    }
    var u = scale * cx;
    var v = scale * cy;
    bmp.context.save();
    bmp.context.translate(x, y);
    bmp.context.rotate(math_1.fix_to_rad(angle));
    bmp.context.translate(-u, -v);
    bmp.context.scale(scale, scale);
    bmp.context.translate(x, y);
    bmp.context.scale(-1, 1);
    bmp.context.translate(-x - sprite.w, -y);
    bmp.context.drawImage(sprite.canvas, 0, 0);
    bmp.context.restore();
}
exports.pivot_scaled_sprite_v_flip = pivot_scaled_sprite_v_flip;
//# sourceMappingURL=sprites.js.map