"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports._timer_lookup = exports.rest_callback = exports.rest = exports.retrace_count = exports.remove_param_int = exports.install_param_int_ex = exports.install_param_int = exports.remove_int = exports.END_OF_FUNCTION = exports.LOCK_FUNCTION = exports.LOCK_VARIABLE = exports.install_int_ex = exports.BPM_TO_TIMER = exports.BPS_TO_TIMER = exports.MSEC_TO_TIMER = exports.SECS_TO_TIMER = exports.install_int = exports.remove_timer = exports.install_timer = exports.timer_driver = void 0;
var debug_1 = require("./debug");
exports.timer_driver = {
    id: 0,
    name: "Browser Timer",
    desc: " Browser Timer",
    ascii_name: "Browser Timer",
};
function install_timer() {
    install_int(function () {
        exports.retrace_count += 1;
    }, 1000 / 70);
    return 0;
}
exports.install_timer = install_timer;
function remove_timer() {
}
exports.remove_timer = remove_timer;
function install_int(proc, speed) {
    install_int_ex(proc, MSEC_TO_TIMER(speed));
}
exports.install_int = install_int;
function SECS_TO_TIMER(secs) {
    return secs * 1000;
}
exports.SECS_TO_TIMER = SECS_TO_TIMER;
function MSEC_TO_TIMER(msec) {
    return msec;
}
exports.MSEC_TO_TIMER = MSEC_TO_TIMER;
function BPS_TO_TIMER(bps) {
    return 1000 / bps;
}
exports.BPS_TO_TIMER = BPS_TO_TIMER;
function BPM_TO_TIMER(bpm) {
    return (60 * 1000) / bpm;
}
exports.BPM_TO_TIMER = BPM_TO_TIMER;
function install_int_ex(proc, speed) {
    var timer_id = window.setInterval(proc, speed);
    _installed_timers.push({ timer: proc, id: timer_id });
    debug_1.log("Added insterrupt #" + timer_id + " at " + speed + "msec isntervals!");
}
exports.install_int_ex = install_int_ex;
function LOCK_VARIABLE(variable_name) {
    void variable_name;
}
exports.LOCK_VARIABLE = LOCK_VARIABLE;
function LOCK_FUNCTION(function_name) {
    void function_name;
}
exports.LOCK_FUNCTION = LOCK_FUNCTION;
function END_OF_FUNCTION(function_name) {
    void function_name;
}
exports.END_OF_FUNCTION = END_OF_FUNCTION;
function remove_int(proc) {
    _installed_timers.forEach(function (timer, index) {
        if (timer.timer === proc) {
            debug_1.log("Removing interrupt " + timer.id + "!");
            window.clearInterval(timer.id);
            _installed_timers.splice(index, 1);
        }
    });
}
exports.remove_int = remove_int;
function install_param_int(procedure, param, speed) {
    install_param_int_ex(procedure, param, speed);
}
exports.install_param_int = install_param_int;
function install_param_int_ex(procedure, param, speed) {
    void procedure;
    void param;
    void speed;
}
exports.install_param_int_ex = install_param_int_ex;
function remove_param_int(proc, param) {
    void proc;
    void param;
}
exports.remove_param_int = remove_param_int;
exports.retrace_count = 0;
function rest(time) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2, new Promise(function (resolve) {
                    setTimeout(resolve, time);
                })];
        });
    });
}
exports.rest = rest;
function rest_callback(time, callback) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            if (!callback) {
                return [2, rest(time)];
            }
            return [2, new Promise(function (resolve) {
                    setTimeout(resolve, time);
                })];
        });
    });
}
exports.rest_callback = rest_callback;
function _timer_lookup(proc) {
    var _a;
    return (_a = _installed_timers.find(function (t) { return t.timer === proc; })) !== null && _a !== void 0 ? _a : -1;
}
exports._timer_lookup = _timer_lookup;
var _installed_timers = [];
//# sourceMappingURL=timer.js.map